// constants
const REMINDER_FOX_MIGRATED_PREF_VERSION="0.9.7";

const REMINDER_PROPERTY_DELIMITER = "`";
const REMINDER_SEPARATOR = "~";
const REMINDER_FOX_OCCURRENCE_ONCE = "1";
const REMINDER_TO_BE_COMPLETED_DELIMITER = "@";
const REMINDER_FOX_MONTHLY_WILDCARD_CHAR = '*';
const REMINDER_FOX_MONTHLY_WILDCARD_STR = "*";
const REMINDER_IMPORTANT_FLAG = "!";

const REMINDER_PRIORITY_NORMAL = 0;
const REMINDER_PRIORITY_IMPORTANT = 1;

const REMINDER_RECURRENCE_YEARLY = 0;
const REMINDER_RECURRENCE_MONTHLY_DATE = 1;
const REMINDER_RECURRENCE_ONETIME = 2;
const REMINDER_RECURRENCE_MONTHLY_DAY = 3;
const REMINDER_RECURRENCE_WEEKLY = 4;
const REMINDER_RECURRENCE_WEEKLY_ALTERNATING = 5;
const REMINDER_RECURRENCE_YEARLY_DAY = 6;
const REMINDER_RECURRENCE_DAILY = 7;

const REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE = 0;
const REMINDERFOX_REMIND_UNTIL_COMPLETE_TO_BE_MARKED = 1;
const REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED = 2;

const REMINDERFOX_FILE_LAST_MODIFIED="X-REMINDERFOX-LAST-MODIFIED";

const REMINDER_FOX_DOMonth = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];// # of days in Non-Leap year Month 
const REMINDER_FOX_lDOMonth = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31]; // # of days in Leap year Month 

// configurable preferences   
const REMINDER_FOX_ENABLE_ALERT_PREF = "enableAlertFor"; 
const REMINDER_FOX_ENABLE_ALERT_PREF_NONE = "none"; 
const REMINDER_FOX_ENABLE_ALERT_PREF_TODAY = "today"; 
const REMINDER_FOX_ENABLE_ALERT_PREF_UPCOMING = "upcoming"; 
const REMINDER_FOX_ENABLE_ALERT_PREF_ALL = "all"; 
const REMINDER_FOX_SUSPEND_ALERT_PREF = "SUSPENDED:";

const REMINDER_FOX_ALERT_TIMEOUT_PREF="alertTimeout";
const REMINDER_FOX_ALERT_TIMEOUT_DEFAULT = 120; // number of minutes between alerts

const UPCOMING_REMINDER_DAYS_PREF="upcomingReminderDays";
const UPCOMING_REMINDER_DAYS_DEFAULT = 15;

const REMINDER_FOX_UPCOMING_REMINDERS_LABEL="upcomingRemindersLabel";
const REMINDER_FOX_UPCOMING_REMINDERS_LABEL_DEFAULT="[longMonth] [date]: [reminderDesc] ([time])";

const REMINDER_FOX_TODAYS_REMINDERS_LABEL="todaysRemindersLabel";
const REMINDER_FOX_TODAYS_REMINDERS_LABEL_DEFAULT="[reminderDesc] ([time])";

const REMINDER_FOX_LIST_DATE_LABEL="listDateLabel";
const REMINDER_FOX_LIST_DATE_LABEL_DEFAULT = "[longMonth] [date]";

const REMINDER_FOX_SHOW_STATUS_TEXT="showReminderStatusText";
const REMINDER_FOX_SHOW_STATUS_TEXT_DEFAULT=true;

const REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP="showRemindersInTooltip";
const REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP_DEFAULT=true;

const REMINDER_FOX_SHOW_TODOS_IN_TOOLTIP="showTodosInTooltip";
const REMINDER_FOX_SHOW_TODOS_IN_TOOLTIP_DEFAULT=true;

const REMINDER_FOX_ALARM_SOUND="alarmSound";
const REMINDER_FOX_ALARM_SOUND_DEFAULT=true;

const REMINDER_FOX_ALERT_SOUND="alertSound";
const REMINDER_FOX_ALERT_SOUND_DEFAULT=false;

const REMINDER_FOX_ALARM_SOUND_PATH="alarmSoundPath";
const REMINDER_FOX_ALARM_SOUND_PATH__DEFAULT="";

const REMINDER_FOX_USE_24_HOUR_TIME="use24HourTime";
const REMINDER_FOX_USE_24_HOUR_TIME_DEFAULT=false;

const REMINDER_FOX_ALARMS_ENABLED="alarmsEnabled";
const REMINDER_FOX_ALARMS_ENABLED_DEFAULT=true;

const REMINDER_FOX_DEFAULT_REPEAT="reminderDefaultRepeat";
const REMINDER_FOX_DEFAULT_ALARM_TIME="reminderDefaultAlarmTime";
const REMINDER_FOX_DEFAULT_ALARM_UNITS="reminderDefaultAlarmUnits";
const REMINDER_FOX_DEFAULT_REMIND_UNTIL_COMPLETED="reminderDefaultRemindUntilCompleted";
const REMINDER_FOX_DEFAULT_ALL_DAY="reminderDefaultAllDay";


const REMINDER_FOX_CALENDAR_START_DAY="calendarStartDay";
const REMINDER_FOX_CALENDAR_START_DAY_DEFAULT= 0;

const REMINDER_FOX_TOOLBAR="toolbar";
const REMINDER_FOX_TOOLBAR_DEFAULT="status-bar";

const REMINDER_FOX_DEFAULT_EDIT="defaultEdit";
const REMINDER_FOX_DEFAULT_EDIT_DEFAULT="reminders";

const REMINDER_FOX_TOOLBAR_POSITION = "toolbarPosition";
const REMINDER_FOX_TOOLBAR_POSITION_DEFAULT = -1;

const REMINDER_FOX_REPEAT_PREVIOUS_OCCURRENCES = "repeatPreviousOccurrences";
const REMINDER_FOX_REPEAT_UPCOMING_OCCURRENCES = "repeatUpcomingOccurrences";

const REMINDER_FOX_MIGRATED_PREF="migrated";

const REMINDER_FOX_PREF = "extensions.reminderFox";



// network
const REMINDER_FOX_NETWORK_SYNCHRONIZE = "network.synchronize";
const REMINDER_FOX_NETWORK_SYNCHRONIZE_DEFAULT = false;
const REMINDER_FOX_PROTO = "network.protocol";
const REMINDER_FOX_DEFAULT_PROTO = "ftp";
const REMINDER_FOX_ADDRESS = "network.address";
const REMINDER_FOX_USERNAME = "network.username";

const REMINDER_FOX_UI_MODE_HEADLESS_SHOW_ALL_UI = 0;
const REMINDER_FOX_UI_MODE_HEADLESS = 1;
const REMINDER_FOX_UI_MODE_HEADLESS_SHOW_ERRORS = 2;


// old reminder/todo strings for migration purposes
const REMINDER_FOX_REMINDERS = "reminderFox.reminders";
const REMINDER_FOX_TODOS = "reminderFox.todos";

const REMINDER_FOX_STORE_FILE =  "storeFile";

const REMINDER_FOX_DEBUG = "debug";
const REMINDER_FOX_LOG = REMINDER_FOX_DEBUG + "." + "loglevel";
const REMINDER_FOX_LOG_LEVEL_NONE = 0;
const REMINDER_FOX_LOG_LEVEL_INFO = 1;
const REMINDER_FOX_LOG_LEVEL_FINE = 2;
const REMINDER_FOX_LOG_DEFAULT =REMINDER_FOX_LOG_LEVEL_NONE;
const REMINDER_FOX_LAST_UPDATE =  "lastUpdate";
const REMINDER_FOX_LAST_ALERT = "lastAlert";
const REMINDER_FOX_LAST_PROCESSED = "lastProcessed";
const REMINDER_FOX_LAST_MODIFIED = "lastModified";

// images
const REMINDER_FOX_NOTES_IMAGE =  "chrome://reminderfox/skin/images/notes.png";
const REMINDER_FOX_REMIND_UNTIL_COMPLETED_TO_BE_MARKED_IMAGE = "chrome://reminderfox/skin/images/ribbon-blue-small.png";
const REMINDER_FOX_REMIND_UNTIL_COMPLETED_IMAGE = "chrome://reminderfox/skin/images/ribbon-red-small.png";
const REMINDER_FOX_COMPLETED_IMAGE = "chrome://global/skin/checkbox/cbox-check.gif";
const REMINDER_FOX_COMPLETED_TODO_IMAGE = "chrome://global/skin/checkbox/cbox-check.gif";
const REMINDER_FOX_SHOW_IN_TOOLTIP_IMAGE = "chrome://reminderfox/skin/images/tooltip.png";
	
// The number of milliseconds in one day
const REMINDER_FOX_ONE_DAY = 1000 * 60 * 60 * 24

const reminderFox_prefs = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch);
                
const reminderFox_prefsBranch = Components.classes["@mozilla.org/preferences-service;1"]. 
				getService(Components.interfaces.nsIPrefService). 
				getBranch(REMINDER_FOX_PREF + ".");
				
				              
const reminderFox_nsISupportsString = Components.interfaces.nsISupportsString;
const reminderFox_consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);

var reminderFox_lastModifiedTime;
var reminderFox_weekday=new Array("SU", "MO", "TU", "WE", "TH", "FR", "SA" );

var reminderFoxEvents;
var reminderFoxTodos;
var global_reminderFoxBundle;

function reminderFox_getBundle() {
	if ( global_reminderFoxBundle == null ) {
		global_reminderFoxBundle = document.getElementById("reminderFox-bundle");  
	}
	return global_reminderFoxBundle;
}

function reminderFox_logMessageLevel(logString, level){
	var logLevel = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LOG);
	if ( level <= logLevel  ) {
	    if(reminderFox_consoleService) {
	      reminderFox_consoleService.logStringMessage("reminderFox: " + logString);
	      if ( logLevel >= 2 ) {
	      	dump( "reminderFox: " + logString + "\n"  );
	      }
	    }
  	}
}
 
/* get unicode string value from preference store */
function reminderFox_getUnicodePref(prefName) {
    return reminderFox_prefs.getComplexValue(prefName, reminderFox_nsISupportsString).data;
}

/* set unicode string value */
function reminderFox_setUnicodePref(prefName,prefValue) {
    var sString = Components.classes["@mozilla.org/supports-string;1"].createInstance(reminderFox_nsISupportsString);
    sString.data = prefValue;
    reminderFox_prefsBranch.setComplexValue(prefName,reminderFox_nsISupportsString,sString);
}

// Object representing reminder events
function ReminderFoxEvent( reminderId, reminderDate, reminderSummary ) {
	this.id = reminderId;
    this.date = reminderDate;    // date object for reminder (using current year)
    this.summary = reminderSummary;  // text of reminder
    this.notes = null;
    this.recurrence = REMINDER_RECURRENCE_YEARLY;  
    this.priority = REMINDER_PRIORITY_NORMAL;
    this.remindUntilCompleted = REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE;
    this.allDayEvent = true;
    this.alarm = null;
    this.alarmLastAcknowledge = null;
    this.lastModified = null;
    this.recurrenceEndDate = null;
    this.complete = false;
   // this.categories = null;
}

// Object representing ToDos
function ReminderFoxTodo( todoId, todoSummary ) {
	this.id = todoId;
    this.summary = todoSummary;
    this.priority = REMINDER_PRIORITY_NORMAL;
    this.dateStamp = null;
    this.notes = null;    
 //   this.categories = null;
    this.showInTooltip = false;
    this.complete = false;   // has this ToDo been marked as completed?
}

/*
 * make a clone object of an event - useful if you want to temporarily modify some properties of an event, 
 * but don't want to change the actual model 
 */
function reminderFox_cloneReminderFoxEvent( reminderFoxEvent ) {
	var newDate = new Date( reminderFoxEvent.date.getFullYear(), reminderFoxEvent.date.getMonth(), reminderFoxEvent.date.getDate(), reminderFoxEvent.date.getHours(), reminderFoxEvent.date.getMinutes() );
	var newReminderFoxEvent = new ReminderFoxEvent( reminderFoxEvent.id, newDate, reminderFoxEvent.summary );
	newReminderFoxEvent.notes = reminderFoxEvent.notes;
	newReminderFoxEvent.recurrence = reminderFoxEvent.recurrence;
	newReminderFoxEvent.priority = reminderFoxEvent.priority;
	newReminderFoxEvent.remindUntilCompleted = reminderFoxEvent.remindUntilCompleted;
	newReminderFoxEvent.complete = reminderFoxEvent.complete;	
//	newReminderFoxEvent.categories = reminderFoxEvent.categories;
	newReminderFoxEvent.allDayEvent = reminderFoxEvent.allDayEvent;
	newReminderFoxEvent.alarm = reminderFoxEvent.alarm;
    newReminderFoxEvent.recurrenceEndDate = reminderFoxEvent.recurrenceEndDate;
    newReminderFoxEvent.alarmLastAcknowledge = reminderFoxEvent.alarmLastAcknowledge;
    newReminderFoxEvent.lastModified = reminderFoxEvent.lastModified;
	return newReminderFoxEvent;
}	



/*
 * make a clone object of an event - useful if you want to temporarily modify some properties of an event, 
 * but don't want to change the actual model 
 */
function reminderFox_cloneReminderFoxTodo( reminderFoxTodo ) {
	var newReminderFoxTodo = new ReminderFoxTodo(  reminderFoxTodo.id, reminderFoxTodo.summary );
	newReminderFoxTodo.priority = reminderFoxTodo.priority;
	newReminderFoxTodo.showInTooltip = reminderFoxTodo.showInTooltip;
	newReminderFoxTodo.notes = reminderFoxTodo.notes;
	newReminderFoxTodo.complete = reminderFoxTodo.complete;
	//newReminderFoxTodo.categories = reminderFoxTodo.categories;
	return newReminderFoxTodo;
}	

function reminderFox_isLeapYear(year) { 
	return (((year % 4 == 0) && (year % 100 != 0)) || (year % 400 == 0)) ? true : false;
}

function reminderFox_openURL(aURL) {
    var uri = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
    uri.spec = aURL;
    var protocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].getService(Components.interfaces.nsIExternalProtocolService);
    protocolSvc.loadUrl(uri);
}


function reminderFox_getMonthAsInteger(monthTextValue) {
	var prefMonth;
	switch (monthTextValue.toUpperCase()) {
		case reminderFox_getBundle().getString("rf.options.month.0.name").toUpperCase():
			prefMonth = 0;
			break;

		case reminderFox_getBundle().getString("rf.options.month.1.name").toUpperCase():
			prefMonth = 1;
			break;

		case reminderFox_getBundle().getString("rf.options.month.2.name").toUpperCase():
			prefMonth = 2;
			break;

		case reminderFox_getBundle().getString("rf.options.month.3.name").toUpperCase():
			prefMonth = 3;
			break;

		case reminderFox_getBundle().getString("rf.options.month.4.name").toUpperCase():
			prefMonth = 4;
			break;

		case reminderFox_getBundle().getString("rf.options.month.5.name").toUpperCase():
			prefMonth = 5;
			break;

		case reminderFox_getBundle().getString("rf.options.month.6.name").toUpperCase():
			prefMonth = 6;
			break;

		case reminderFox_getBundle().getString("rf.options.month.7.name").toUpperCase():
			prefMonth = 7;
			break;

		case reminderFox_getBundle().getString("rf.options.month.8.name").toUpperCase():
			prefMonth = 8;
			break;

		case reminderFox_getBundle().getString("rf.options.month.9.name").toUpperCase():
			prefMonth = 9;
			break;

		case reminderFox_getBundle().getString("rf.options.month.10.name").toUpperCase():
			prefMonth = 10;
			break;

		case reminderFox_getBundle().getString("rf.options.month.11.name").toUpperCase():
			prefMonth = 11;
			break;
					
	}
	return prefMonth;

}

function reminderFox_getShortMonthAsInteger(monthTextValue) {
	var prefMonth;
	switch (monthTextValue.toUpperCase()) {
		case reminderFox_getBundle().getString("rf.options.month.0.Mmm").toUpperCase():
			prefMonth = 0;
			break;

		case reminderFox_getBundle().getString("rf.options.month.1.Mmm").toUpperCase():
			prefMonth = 1;
			break;

		case reminderFox_getBundle().getString("rf.options.month.2.Mmm").toUpperCase():
			prefMonth = 2;
			break;

		case reminderFox_getBundle().getString("rf.options.month.3.Mmm").toUpperCase():
			prefMonth = 3;
			break;

		case reminderFox_getBundle().getString("rf.options.month.4.Mmm").toUpperCase():
			prefMonth = 4;
			break;

		case reminderFox_getBundle().getString("rf.options.month.5.Mmm").toUpperCase():
			prefMonth = 5;
			break;

		case reminderFox_getBundle().getString("rf.options.month.6.Mmm").toUpperCase():
			prefMonth = 6;
			break;

		case reminderFox_getBundle().getString("rf.options.month.7.Mmm").toUpperCase():
			prefMonth = 7;
			break;

		case reminderFox_getBundle().getString("rf.options.month.8.Mmm").toUpperCase():
			prefMonth = 8;
			break;

		case reminderFox_getBundle().getString("rf.options.month.9.Mmm").toUpperCase():
			prefMonth = 9;
			break;

		case reminderFox_getBundle().getString("rf.options.month.10.Mmm").toUpperCase():
			prefMonth = 10;
			break;

		case reminderFox_getBundle().getString("rf.options.month.11.Mmm").toUpperCase():
			prefMonth = 11;
			break;
					
	}
	return prefMonth;

}


function reminderFox_getMonthAsText(integerValue) {
	return reminderFox_getBundle().getString("rf.options.month."+integerValue+".name");
}


function reminderFox_loadDefaultPreferences() {

	try {
		var oldVersionNumber = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_MIGRATED_PREF);
		if ( oldVersionNumber != REMINDER_FOX_MIGRATED_PREF_VERSION ) {
			// this is an older version; we need to handle migration code	
			reminderFox_handleMigration( oldVersionNumber );				
		}		
	} catch(e) {
		// this is an older version; we need to handle migration code		
		reminderFox_handleMigration("0.0");
	}				
	

	try {
		reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TOOLBAR_POSITION);
	} catch(e) {
		reminderFox_prefsBranch.setIntPref(REMINDER_FOX_TOOLBAR_POSITION, REMINDER_FOX_TOOLBAR_POSITION_DEFAULT);
		
		try {
			// set the default location to the current location as of this moment
		    var reminderFox_toolbar = document.getElementById(reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TOOLBAR));
		    var box = document.getElementById("reminderFox-statusLabel");
		    if (reminderFox_toolbar) {
		    	var currentIndex = reminderFox_indexOf(reminderFox_toolbar, box, true);
		    	reminderFox_prefsBranch.setIntPref(REMINDER_FOX_TOOLBAR_POSITION, currentIndex);	    	
		    }
		}
		catch (e) {
		}
	}	

	try {
		// clear out last alert time - because we always want to show the alert slider at least once on startup
		reminderFox_prefsBranch.setCharPref( REMINDER_FOX_LAST_ALERT, "");	
	} catch(e) {		
	}		
	
	try {
		reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LAST_MODIFIED);
	} catch(e) {
		reminderFox_prefsBranch.setCharPref(REMINDER_FOX_LAST_MODIFIED, 	"");
	}
		
//	try {
//		// clear out last process  time - because we always want to process  on startup
//		reminderFox_prefsBranch.setCharPref( REMINDER_FOX_LAST_PROCESSED, "");	
//	} catch(e) {		
//	}
}

function reminderFox_getSortedIndexOfNewReminder(  reminderFoxEvents, newreminder, addUniqueOnly  ) {	
	var month = newreminder.date.getMonth();


	// We go through each reminder and then compare that reminder's month with 
	// the reminder-to-be-added month, and if the new month is less, add there;
	// if the months are equal, then compare the days and add appropriately. 
	for ( var i = 0; i < reminderFoxEvents.length; i++ ) {
		var reminder = reminderFoxEvents[i];
		
		// add current reminder before reminders from later months
		if (   month < reminder.date.getMonth()) { 
			return i;
		}
		// if they have the same month, then compare dates
		else if ( month == reminder.date.getMonth() ) {
			if ( newreminder.date.getDate()  <  reminder.date.getDate() ) {
				return i;
			}
			else if (  newreminder.date.getDate() == reminder.date.getDate() ) {					
				if ( addUniqueOnly && newreminder.summary == reminder.summary ) {
					// this reminder is already in the list; just ignore it
					return -1;
				}
				else {
					if ( !newreminder.allDayEvent ) { 
						// this is an hourly event.  Let's place it chronologically
						if ( reminder.allDayEvent ) {
							// the current reminder is all day; let's put chronological events 
							// first
							return i;
						}
						else {
							// the current reminder is an hour event as well; let's place them
							// chronologically.
							if ( newreminder.date.getHours() < reminder.date.getHours() || 
								( newreminder.date.getHours() == reminder.date.getHours() && newreminder.date.getMinutes() < reminder.date.getMinutes() )  ){
									return i;
							}						
						}
					}					 
					// if this is an Imp	ortant reminder, add it before other reminders of the same day
					else if ( newreminder.priority == REMINDER_PRIORITY_IMPORTANT  ) {
						return i;
					}
				}
			}
		}  // monthly			
	} // for
	
	return reminderFoxEvents.length;
}	

  function reminderFox_indexOf(aParent, aChild, overrideLast)  { 
    // -1 if it does not exist
    var children = aParent.childNodes;
    if ( children == null ) {
    	return null;
    }
    for (var x=0; x<children.length; x++) {
	    if (children[x] == aChild) {
			if ( overrideLast ) {
				return x;
			}
			else {
				return (x == children.length - 1) ? -1 : x;
			}
	    }
    }
    return null;
  }
  




function reminderFox_getSortedIndexOfNewTodo(  reminderFoxTodos, newTodo ) {
	// if current todo is important, add to start of list
    if (newTodo.priority == REMINDER_PRIORITY_IMPORTANT  ) {
		// insert at beginning
		return 0;
    }
    else {
    	// run through until find one that's not important, and add new one before it
		 for( var i = 0; i < reminderFoxTodos.length; i++) {
	        if ( !reminderFoxTodos[i].priority == REMINDER_PRIORITY_IMPORTANT  ) {
	        	if ( newTodo.showInTooltip ) {
					return i;
	        	}
	        	else {
	        		if ( !reminderFoxTodos[i].showInTooltip ) {
						return i;
	        		}
	        	}	        
	        }
		}
    }
	
	// if the reminder hasn't been added yet, then place it at the end
	return reminderFoxTodos.length;			
}
 
 function reminderFox_getValidDateForMonth( year, month, date ) {
	var lastValidDate = date;	
	var lastDayOfMonth = oeDatePicker.getLastDayOfMonth( year, month );
	if ( date > lastDayOfMonth ) {
		lastValidDate = lastDayOfMonth;
	}
	return lastValidDate;
}
 
 /*
  *DEPRECATED - for migration only 
 */
 function reminderFox_sortNewReminder( reminders, newreminder, monthInt, dayInt, addUniqueOnly  ) {
	var leftSideOfReminders, rightSideOfReminders;
	
	// We go through each reminder and then compare that reminder's month with 
	// the reminder-to-be-added month, and if the new month is less, add there;
	// if the months are equal, then compare the days and add appropriately. 
	if (reminders != "") {
	 	var index = 0;
		var endIndex = reminders.indexOf( REMINDER_SEPARATOR );
		if ( endIndex == -1 ) {
			endIndex = reminders.length ;
		}
		var added = false;
		while ( endIndex != -1 && !added ) {
			var currentReminder;
			if ( endIndex == reminders.length - 1 ) {
				currentReminder = reminders.substring( index, endIndex + 1 );
			}
			else {
				currentReminder = reminders.substring( index, endIndex );
			}
			var reminderArray = currentReminder.split(REMINDER_PROPERTY_DELIMITER);

			var myMonth;
			var reminderMon;
			// treat Monthly reminders as coming at the end of the list
			if ( monthInt == REMINDER_FOX_MONTHLY_WILDCARD_CHAR ) {
				myMonth = 12;
			}
			else {
			    myMonth = parseInt( monthInt );
			}
			if ( reminderArray[0] == REMINDER_FOX_MONTHLY_WILDCARD_CHAR ) { 
				reminderMon = 12;
			}
			else {
				reminderMon = parseInt(reminderArray[0]);
			}
		
			// add current reminder before reminders from later months
			if (  myMonth < reminderMon) { 
				leftSideOfReminders = reminders.substring(0, index );						
				rightSideOfReminders = reminders.substring(index ,  reminders.length);					
				reminders = leftSideOfReminders + newreminder + REMINDER_SEPARATOR + rightSideOfReminders;
				added = true;
			}
			// if they have the same month, then compare dates
			else if ( reminderMon == myMonth ) {
				var myDay = parseInt(dayInt);
				var reminderDay = parseInt(reminderArray[1]);
				if ( myDay < reminderDay ) {
					leftSideOfReminders = reminders.substring(0, index );							
					rightSideOfReminders = reminders.substring(index ,  reminders.length);					
					reminders = leftSideOfReminders + newreminder + REMINDER_SEPARATOR + rightSideOfReminders;
					added = true;
				}
				else if ( myDay == reminderDay ) {
					var newReminderArray = newreminder.split(REMINDER_PROPERTY_DELIMITER);
					if ( addUniqueOnly && newReminderArray[2] == reminderArray[2] ) {
						// this reminder is already in the list; just ignore it
						added = true;
					}
					else {
						// if this is an Important reminder, add it before other reminders of the same day
						var indexImportant = newreminder.indexOf( REMINDER_PROPERTY_DELIMITER + REMINDER_IMPORTANT_FLAG );
						if ( indexImportant != -1 ) {
							leftSideOfReminders = reminders.substring(0, index );							
							rightSideOfReminders = reminders.substring(index ,  reminders.length);					
							reminders = leftSideOfReminders + newreminder + REMINDER_SEPARATOR + rightSideOfReminders;
							added = true;
						}
					}
				}
			}
			index = endIndex + 1;
			endIndex = reminders.indexOf( REMINDER_SEPARATOR, index );		
			if ( index != reminders.length && endIndex == -1 ) {
				endIndex = reminders.length - 1;
			}
		}
		
		// if the reminder hasn't been added yet, then place it at the end
		// of the list
		if ( !added ) {
			reminders += REMINDER_SEPARATOR + newreminder;
		}	
	}	
	else {
		reminders += newreminder;
	}	
	return reminders;
}
 
function reminderFox_handleMigration(oldVersion) {
		// set version number to new current version
		try {
			reminderFox_prefsBranch.setCharPref(REMINDER_FOX_MIGRATED_PREF, REMINDER_FOX_MIGRATED_PREF_VERSION);		
		} catch(e) {		
		}	
		
		// this is an older version; we need to handle migration code		
		if ( oldVersion <=  "0.5.8" ) {					
			// migrate old pref strings to new values
			var oldVal;			
			var OLD_REMINDER_FOX_PREF = "reminderFox";
			
			try { 
				oldVal = reminderFox_prefs.getCharPref(OLD_REMINDER_FOX_PREF + "." + REMINDER_FOX_ENABLE_ALERT_PREF);
				reminderFox_prefsBranch.setCharPref(REMINDER_FOX_ENABLE_ALERT_PREF, oldVal);
			} catch(e) {
			}
			
			try {
				oldVal = reminderFox_prefs.getCharPref(OLD_REMINDER_FOX_PREF + "." + REMINDER_FOX_ALERT_TIMEOUT_PREF);
				reminderFox_prefsBranch.setIntPref(REMINDER_FOX_ALERT_TIMEOUT_PREF, parseInt(oldVal));
			} catch(e) {			
			}
			
			try {
				oldVal = reminderFox_prefs.getCharPref(OLD_REMINDER_FOX_PREF + "." + UPCOMING_REMINDER_DAYS_PREF);
				reminderFox_prefsBranch.setIntPref(UPCOMING_REMINDER_DAYS_PREF, parseInt(oldVal));
			} catch(e) {				
			}
			
			try {
				oldVal = reminderFox_prefs.getBoolPref(OLD_REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_STATUS_TEXT);
				reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_SHOW_STATUS_TEXT, oldVal);
			} catch(e) {				
			}	
			
			try {
				oldVal = reminderFox_prefs.getBoolPref(OLD_REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP);
				reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP, REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP_DEFAULT);
			} catch(e) {				
			}	
		
			try {
				oldVal =reminderFox_prefs.getBoolPref(OLD_REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_TODOS_IN_TOOLTIP);
				reminderFox_prefsBranch.setBoolPref(REMINDER_FOX_SHOW_TODOS_IN_TOOLTIP, oldVal);
			} catch(e) {				
			}					
				
			try {
				oldVal = reminderFox_prefs.getCharPref(OLD_REMINDER_FOX_PREF + "." + REMINDER_FOX_TOOLBAR);
				reminderFox_prefsBranch.setCharPref(REMINDER_FOX_TOOLBAR, oldVal);
			} catch(e) {				
			}		
				
			try {
				oldVal =reminderFox_prefs.getIntPref(OLD_REMINDER_FOX_PREF + "." + REMINDER_FOX_TOOLBAR_POSITION);
				reminderFox_prefsBranch.setIntPref(REMINDER_FOX_TOOLBAR_POSITION, oldVal);
			} catch(e) {	
			}	
			
			try {
				oldVal = reminderFox_prefs.getCharPref(OLD_REMINDER_FOX_PREF + "." + REMINDER_FOX_DEFAULT_EDIT);
				reminderFox_prefsBranch.setCharPref(REMINDER_FOX_DEFAULT_EDIT, oldVal );
			} catch(e) {			
			}		
			
			try {
				oldVal = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LAST_ALERT);
				reminderFox_prefsBranch.setCharPref(REMINDER_FOX_LAST_ALERT, oldVal);	
			} catch(e) {		
			}	
			
			

				
			// read in old format if it's there and save to new persisted format
			try { 
				// check if old pref string exists
				var oldReminders = reminderFox_getUnicodePref(REMINDER_FOX_REMINDERS);

				// now write file out to filesystem (but only if the destination file does not already
				// exist (we don't want to overwrite anything if it's already there)
				var file = reminderFox_getReminderStoreFile();
			 
				try {
					netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
				} catch (e) {
					alert("Permission to save file was denied.");
				}

				if ( file.exists() == false ) {	
					// no existing ics file is there - let's convert pref string to ics file		;
					var i, j;				
								
					var oldTodos = "";
					try {
						oldTodos = reminderFox_getUnicodePref(REMINDER_FOX_TODOS);
					}
					catch (e) {
					}					

					reminderFox_readInRemindersAndTodos(reminderFox_getReminderEvents(), reminderFox_getReminderTodos(), oldReminders, oldTodos);
					reminderFox_writeOutRemindersAndTodos(false);								
					reminderFox_syncWrittenChangesToRemote();
				}			
			}
			catch ( e ) {
				// the old pref string doesn't exist... nothing to migrate
			}	
		}
}

function reminderFox_getAlarmInMinutes( alarm ) {
		if ( alarm == null ) {
			return null;
		}
		// example: TRIGGER;VALUE=DURATION: -PT30M
		var alarmTime = alarm;
		var result = null;						 
		var alarmIndex1 = alarmTime.indexOf( "-PT" );
		if ( alarmIndex1 != -1 ) {
			var alarmIndex2 = alarmTime.indexOf( "M", alarmIndex1 );
			if ( alarmIndex2 != -1 ) {
				alarmTime = alarmTime.substring( alarmIndex1 + "-PT".length, alarmIndex2 );		
				result = parseInt( alarmTime );	
			}
			else {
				alarmIndex2 = alarmTime.indexOf( "H", alarmIndex1 );
				if ( alarmIndex2 != -1 ) {
					alarmTime = alarmTime.substring( alarmIndex1 + "-PT".length, alarmIndex2 );		
					result = parseInt(alarmTime) * 60;
				}	
			}	
		}
		else {
			alarmIndex1 = alarmTime.indexOf( "-P" );
			if ( alarmIndex1 != -1 ) {
				var alarmIndex2 = alarmTime.indexOf( "D", alarmIndex1 );
				if ( alarmIndex2 != -1 ) {
					alarmTime = alarmTime.substring( alarmIndex1 + "-P".length, alarmIndex2 );		
					result = parseInt( alarmTime ) * 24 * 60;					
				}
			}
		}		
		return result;				 
}



// index is the number of the element you wish to remove
// from the array: reminderFoxEvents	
function reminderFox_removeElement(reminderFoxEvents, index) {

    for (index = index; index<reminderFoxEvents.length;index++) {
        // assigns the value of elementnr+1 to elementnr, so you move all items by 1
        reminderFoxEvents[index] = reminderFoxEvents[index + 1];
    }
    reminderFoxEvents.length=reminderFoxEvents.length-1;
    
}

// position is the number where you want to add the new element (reminder) into 
// the array: reminderFoxEvents	
function reminderFox_insertIntoArray(reminderFoxEvents, reminder, position) {
	var origLength = reminderFoxEvents.length;
	if ( position > origLength ) {
		position = origLength;
	}
	
	reminderFoxEvents.length = reminderFoxEvents.length + 1;

	for ( var i = origLength; i >=0; i-- ) {
		if ( i == position ) {
			reminderFoxEvents[i] = reminder;
			break;
		}
		else if ( i > position ) {
			reminderFoxEvents[i] = reminderFoxEvents[i-1];
		}
		else if ( i < position ) {
			break;
		}
	}
}
	

function reminderFox_generateUniqueReminderId(date) {
	return date.getTime() + "-" + Math.round(900000000 + (Math.random() * 100000000));
}

function reminderFox_generateUniqueTodoId() {
	return  Math.round(900000000 + (Math.random() * 100000000));
}	

function reminderFox_readInRemindersAndTodos(reminderFoxEvents, reminderFoxTodos, reminders, todos) {
		var i, j;

		if ( reminders != "" ) {
			var remindersArray = reminders.split(REMINDER_SEPARATOR);
			for( i = 0; i < remindersArray.length; i++) {
					var newreminder = remindersArray[i];
					var year = new Date().getFullYear();
					var recurrence = REMINDER_RECURRENCE_YEARLY;
					var time = null;
					var alarm = null;

					var startIndex, endIndex;
					if ( newreminder.indexOf( "START;")  != -1  ) {
						startIndex = newreminder.indexOf( "year=" );
						if ( startIndex != -1 ) {
							endIndex = newreminder.indexOf( ";", startIndex );
							if ( endIndex != -1 ) {
								year = parseInt(newreminder.substring( startIndex + "year=".length, endIndex ));
							}
						}

						startIndex = newreminder.indexOf( "repeat=" );
						if ( startIndex != -1 ) {
							endIndex = newreminder.indexOf( ";", startIndex );
							if ( endIndex != -1 ) {
								recurrence = newreminder.substring( startIndex + "repeat=".length, endIndex );
							}
						}
	
						startIndex = newreminder.indexOf( "time=" );
						if ( startIndex != -1 ) {
							endIndex = newreminder.indexOf( ";", startIndex );
							if ( endIndex != -1 ) {
								time = newreminder.substring( startIndex + "time=".length, endIndex );								
							}
						}
						
						startIndex = newreminder.indexOf( "alarm=" );
						if ( startIndex != -1 ) {
							endIndex = newreminder.indexOf( ";", startIndex );
							if ( endIndex != -1 ) {
								alarm = newreminder.substring( startIndex + "alarm=".length, endIndex );								
							}													
						}						

						endIndex = newreminder.indexOf( "END;" );
						endIndex = endIndex + "END;".length;
						
						newreminder = newreminder.substring( endIndex, newreminder.length  );						
					}
													
					var reminderArray = newreminder.split(REMINDER_PROPERTY_DELIMITER);			
					var month = reminderArray[0];
					var day = reminderArray[1];

					var date;			
					if ( reminderArray[0] == REMINDER_FOX_MONTHLY_WILDCARD_CHAR ) {
						// set this to Jan (0) if it's monthly; this can be changed when we actually
						// store monthly reminders set for specific months
						date = new Date(year, 0, reminderArray[1] );
					}
					else {
					
						date = new Date( year, reminderArray[0], reminderArray[1] );
					}

					var reminderSummary = reminderArray[2];
					
					var reminderId =reminderFox_generateUniqueReminderId( date );
					var reminderEvent = new ReminderFoxEvent( reminderId, date, reminderSummary );
					reminderEvent.recurrence = recurrence;
					if ( reminderArray[0] == REMINDER_FOX_MONTHLY_WILDCARD_CHAR ) {
						reminderEvent.recurrence = REMINDER_RECURRENCE_MONTHLY_DATE;
					}			
					
					if ( time != null ) {
						reminderEvent.allDayEvent = false;
						var startindex = time.indexOf( ":" );
						if ( startindex != -1 ) {
							var hours = parseInt(time.substring(0, startindex ));
							var minutes = time.substring(startindex+1, time.length);
							reminderEvent.date.setHours( hours, minutes );
						}
					}			
					if ( alarm != null ) {
						reminderEvent.alarm = alarm;
					}		
			
				    // check for any options that are specified, and mark them in the columns 
		            for ( j = 3; j < reminderArray.length; j++ ) {
		                var val = reminderArray[j];
						 if ( val == REMINDER_IMPORTANT_FLAG ) {
		                    reminderEvent.priority = REMINDER_PRIORITY_IMPORTANT;
		                }	
		                else  if ( val == REMINDER_FOX_OCCURRENCE_ONCE ) {
		                    reminderEvent.recurrence = REMINDER_RECURRENCE_ONETIME;
		                }		
		                else  if ( val == REMINDER_TO_BE_COMPLETED_DELIMITER ) {
		                    reminderEvent.complete = true;
		                }	
		                else  if ( val.indexOf(REMINDER_TO_BE_COMPLETED_DELIMITER) == 0  ) {
		                	if (  val.indexOf(REMINDER_TO_BE_COMPLETED_DELIMITER, 1) == 1  ) { 
			                    reminderEvent.remindUntilCompleted = REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED;              
			                    val = val.substring(2, val.length );		                	
		                	}
		                	else {
			                    reminderEvent.remindUntilCompleted = REMINDERFOX_REMIND_UNTIL_COMPLETE_TO_BE_MARKED;			                    
			                    val = val.substring(1, val.length );
			                 }
		                    var remindCompletedArray = val.split("-");			
		                  //  reminderEvent.originalDate = new Date( reminderEvent.originalDate.getFullYear(), parseInt(remindCompletedArray[0]),  	parseInt(remindCompletedArray[1]) );
		                }							                			               
		            }
		            reminderFoxEvents[i] = reminderEvent;
			}
		}
				
		/* TODOS  */
		if ( todos != "" ) {
			var todosArray = todos.split(REMINDER_SEPARATOR);
			for( i = 0; i < todosArray.length; i++) {
					var newTodo = todosArray[i];
					var todoArray = newTodo.split(REMINDER_PROPERTY_DELIMITER);							
					var todoSummary = todoArray[0];
					var todoId = reminderFox_generateUniqueTodoId();
					var todoEvent = new ReminderFoxTodo(  todoId, todoSummary );

					// check for any options that are specified, and mark them in the columns 
		            for ( j = 1; j < todoArray.length; j++ ) {
		                val = todoArray[j];
						 if ( val == REMINDER_IMPORTANT_FLAG ) {
		                    todoEvent.priority = REMINDER_PRIORITY_IMPORTANT;
		                }	
		                else  if ( val == REMINDER_TO_BE_COMPLETED_DELIMITER ) {
		                    todoEvent.showInTooltip = true;
		                }							                			               
		            }		            
		            reminderFoxTodos[i] = todoEvent;							            
			}
		}
	}
	
	function reminderFox_getNextReminderOccurrence( reminder, originalDate, weekNumber ) {
		var reminderCurrentDate = reminder.date;
		
		if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY ) {
			// do nothing; should only be once occurrence per year			
		}
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY_DAY ) { 
			// do nothing; should only be once occurrence per year			
		}
		else 	if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DATE ) {
				var monthReminder = reminderFox_cloneReminderFoxEvent( reminder );		
				
				var month = reminderCurrentDate.getMonth();
				var year = reminderCurrentDate.getFullYear();
				month = month + 1;
			 	if ( month == 12 ) {
			 		month = 0;
			 		year = year + 1;
			 	}
			 	var dayVal = reminderFox_getValidDateForMonth( year, month, originalDate.getDate() );		
				monthReminder.date = new Date( year, month, dayVal, originalDate.getHours(), originalDate.getMinutes() );		
				
				return monthReminder;		 	
		}
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DAY ) {
				var monthReminder = reminderFox_cloneReminderFoxEvent( reminder );		
				
				var month = reminderCurrentDate.getMonth();
				var year = reminderCurrentDate.getFullYear();
				month = month + 1;
			 	if ( month == 12 ) {
			 		month = 0;
			 		year = year + 1;
			 	}
			 	
				var reminderDay = originalDate.getDay();
				var nextMonthDate = new Date( year, month, 1 );
				var reminderWeekDateThisMonth = reminderFox_getDateForSpecifiedWeekNumber( nextMonthDate, reminderDay, weekNumber );
				monthReminder.date = new Date( year, month, reminderWeekDateThisMonth, originalDate.getHours(), originalDate.getMinutes() );				
				return monthReminder;		
		}
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY ) {	
			var weeklyReminder = reminderFox_cloneReminderFoxEvent( reminder );	
			weeklyReminder.date.setDate( weeklyReminder.date.getDate() + 7 );			
			return weeklyReminder;				
		}	
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY_ALTERNATING ) {	
			var weeklyReminder = reminderFox_cloneReminderFoxEvent( reminder );	
			weeklyReminder.date.setDate( weeklyReminder.date.getDate() + 14 );			
			return weeklyReminder;	
		}	
		return null;		
	
	}
	
	function reminderFox_getFirstReminderOccurrenceAfterStartDate( reminder, startDate ) {
		var nexDate;
		var dayVal;		
		var finalDate;
		var todaysDate = new Date();
		
		if ( reminder.recurrence  == REMINDER_RECURRENCE_ONETIME) {		
			return reminder;
		}
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY ) {
			var reminderCurrentDate = reminder.date;
			
			// if start date is less than the default reminder date, return the reminder date
			if (  reminderFox_compareDates( startDate, reminderCurrentDate ) == -1 ) {
				return  reminderFox_cloneReminderFoxEvent( reminder );
			}

			if ( reminderCurrentDate.getMonth() < startDate.getMonth() ) {
				dayVal = reminderFox_getValidDateForMonth(  startDate.getFullYear() + 1, reminderCurrentDate.getMonth(), reminderCurrentDate.getDate() );					
				finalDate = new Date( startDate.getFullYear() + 1, reminderCurrentDate.getMonth(), dayVal, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes() );	
			}
			else if ( reminderCurrentDate.getMonth() > startDate.getMonth() ) {
				dayVal = reminderFox_getValidDateForMonth(  startDate.getFullYear() , reminderCurrentDate.getMonth(), reminderCurrentDate.getDate() );								
				finalDate = new Date( startDate.getFullYear(), reminderCurrentDate.getMonth(), dayVal, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes()  );
			}
			// same month
			else {
				if ( reminderCurrentDate.getDate() < startDate.getDate() ) {
					dayVal = reminderFox_getValidDateForMonth(  startDate.getFullYear() + 1 , reminderCurrentDate.getMonth(), reminderCurrentDate.getDate() );												
					finalDate = new Date( startDate.getFullYear() + 1, reminderCurrentDate.getMonth(), dayVal, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes() );		
				}
				else if ( reminderCurrentDate.getDate() > startDate.getDate() ) {
					dayVal = reminderFox_getValidDateForMonth(  startDate.getFullYear() , reminderCurrentDate.getMonth(), reminderCurrentDate.getDate() );																
					finalDate = new Date( startDate.getFullYear(), reminderCurrentDate.getMonth(), dayVal, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes()  );
				}
				else {   // same date; return it
					dayVal = reminderFox_getValidDateForMonth(  startDate.getFullYear() , reminderCurrentDate.getMonth(), reminderCurrentDate.getDate() );																				
					finalDate = new Date( startDate.getFullYear(), reminderCurrentDate.getMonth(), dayVal, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes()  );
				}
			}
			   
			var yearReminder = reminderFox_cloneReminderFoxEvent( reminder );
			yearReminder.date = finalDate;
			return yearReminder;
		}
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY_DAY ) { 
			var reminderCurrentDate = reminder.date;
			
			// if start date is less than the default reminder date, then use the reminder date as start date
			if (  reminderFox_compareDates( startDate, reminderCurrentDate ) == -1 ) {
				startDate = reminderCurrentDate;
			}

			if ( reminderCurrentDate.getMonth() < startDate.getMonth() ) {
				var reminderDay = reminderCurrentDate.getDay();
				var weekNumber = reminderFox_getWeekNumber( reminder.date );
				var nextYearStartDate = new Date( startDate.getFullYear() + 1, reminderCurrentDate.getMonth(), reminderCurrentDate.getDate() );	
				var reminderWeekDateThisMonth = reminderFox_getDateForSpecifiedWeekNumber( nextYearStartDate, reminderDay, weekNumber );
				dayVal = reminderFox_getValidDateForMonth(  startDate.getFullYear() + 1, reminderCurrentDate.getMonth(), reminderWeekDateThisMonth );			
				finalDate = new Date( startDate.getFullYear() + 1, reminderCurrentDate.getMonth(), dayVal, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes()  );	
				}
			else if ( reminderCurrentDate.getMonth() > startDate.getMonth() ) {
				var reminderDay = reminderCurrentDate.getDay();
				var weekNumber = reminderFox_getWeekNumber( reminder.date );
				var nextYearStartDate = new Date( startDate.getFullYear(), reminderCurrentDate.getMonth(), reminderCurrentDate.getDate() );	
				var reminderWeekDateThisMonth = reminderFox_getDateForSpecifiedWeekNumber( nextYearStartDate, reminderDay, weekNumber );			
				dayVal = reminderFox_getValidDateForMonth(  startDate.getFullYear() , reminderCurrentDate.getMonth(), reminderWeekDateThisMonth );								
				finalDate = new Date( startDate.getFullYear(), reminderCurrentDate.getMonth(), dayVal, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes()  );
			}
			// same month
			else {
				var reminderDay = reminderCurrentDate.getDay();
				var weekNumber = reminderFox_getWeekNumber( reminder.date );
				
				var nextYearStartDate = new Date( startDate.getFullYear(), reminderCurrentDate.getMonth(), reminderCurrentDate.getDate() );	
				var reminderWeekDateThisMonth = reminderFox_getDateForSpecifiedWeekNumber( nextYearStartDate, reminderDay, weekNumber );
			
				if ( reminderWeekDateThisMonth < startDate.getDate() ) {
					nextYearStartDate = new Date( startDate.getFullYear() + 1, reminderCurrentDate.getMonth(), reminderCurrentDate.getDate() );	
					reminderWeekDateThisMonth = reminderFox_getDateForSpecifiedWeekNumber( nextYearStartDate, reminderDay, weekNumber );
					dayVal = reminderFox_getValidDateForMonth(  startDate.getFullYear() + 1 , reminderCurrentDate.getMonth(), reminderWeekDateThisMonth );												
					finalDate = new Date( startDate.getFullYear() + 1, reminderCurrentDate.getMonth(), dayVal, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes()  );		
				}
				else if ( reminderWeekDateThisMonth > startDate.getDate() ) {
					dayVal = reminderFox_getValidDateForMonth(  startDate.getFullYear() , reminderCurrentDate.getMonth(), reminderWeekDateThisMonth );																
					finalDate = new Date( startDate.getFullYear(), reminderCurrentDate.getMonth(), dayVal, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes()  );
				}
				else {   // same date; return it
					dayVal = reminderFox_getValidDateForMonth(  startDate.getFullYear() , reminderCurrentDate.getMonth(), reminderWeekDateThisMonth );																				
					finalDate = new Date( startDate.getFullYear(), reminderCurrentDate.getMonth(), dayVal, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes()  );
				}
			}
			   
			var yearReminder = reminderFox_cloneReminderFoxEvent( reminder );
			yearReminder.date = finalDate;
			return yearReminder;		
		
		}		
		else 	if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DATE ) {
			var reminderCurrentDate = reminder.date;
			// if start date is less than the default reminder date, then use the reminder date as start date
			if (  reminderFox_compareDates( startDate, reminderCurrentDate ) == -1 ) {
				startDate = reminderCurrentDate;
			}
			
			// first check to see if the date of the reminder is less or more than start date.
			// if less, then we need to go to the next month;  if more, than we will use this month
			if ( reminderCurrentDate.getDate() < startDate.getDate() ) {
				var month = startDate.getMonth();
				var year = startDate.getFullYear();
				month = month + 1;
			 	if ( month == 12 ) {
			 		month = 0;
			 		year = year + 1;
			 	}
				var dayVal = reminderFox_getValidDateForMonth( year, month, reminderCurrentDate.getDate() );			 		
				finalDate = new Date( year, month, dayVal, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes()  );		
			}
			else if ( reminderCurrentDate.getDate() > startDate.getDate() ) {
				dayVal = reminderFox_getValidDateForMonth(  startDate.getFullYear() , startDate.getMonth(), reminderCurrentDate.getDate() );											
				finalDate = new Date( startDate.getFullYear(), startDate.getMonth(), dayVal, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes()  );
			}
			else {   // same date; return it
				dayVal = reminderFox_getValidDateForMonth(  startDate.getFullYear() , startDate.getMonth(), reminderCurrentDate.getDate() );											
				finalDate = new Date( startDate.getFullYear(), startDate.getMonth(), dayVal, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes()  );				
			}
			
			var monthReminder = reminderFox_cloneReminderFoxEvent( reminder );
			monthReminder.date = finalDate;
			return monthReminder;
		}
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DAY ) {		
			var reminderCurrentDate = reminder.date;
			// if start date is less than the default reminder date, then use the reminder date as start date
			if (  reminderFox_compareDates( startDate, reminderCurrentDate ) == -1 ) {
				startDate = reminderCurrentDate;
			}
			
			var reminderDay = reminder.date.getDay();
			var weekNumber = reminderFox_getWeekNumber( reminder.date );
			var reminderWeekDateThisMonth = reminderFox_getDateForSpecifiedWeekNumber( startDate, reminderDay, weekNumber );
			
			// first check to see if the date of the reminder is less or more than start date.
			// if less, then we need to go to the next month;  if more, than we will use this month
			if ( reminderWeekDateThisMonth < startDate.getDate() ) {
				var month = startDate.getMonth();
				var year = startDate.getFullYear();
				month = month + 1;
			 	if ( month == 12 ) {
			 		month = 0;
			 		year = year + 1;
			 	}
				var dayVal = reminderFox_getValidDateForMonth( year, month, reminderWeekDateThisMonth );			
				var newDate = new Date( year, month, dayVal );		
				reminderWeekDateThisMonth = reminderFox_getDateForSpecifiedWeekNumber( newDate, reminderDay, weekNumber );
				finalDate = new Date( newDate.getFullYear(), newDate.getMonth(), reminderWeekDateThisMonth, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes()  );
			}
			else if ( reminderWeekDateThisMonth > startDate.getDate() ) {									
				finalDate = new Date( startDate.getFullYear(), startDate.getMonth(), reminderWeekDateThisMonth, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes()  );
			}
			else {   // same date; return it
				finalDate = new Date( startDate.getFullYear(), startDate.getMonth(), reminderWeekDateThisMonth, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes()  );	
			}
			
			var monthReminder = reminderFox_cloneReminderFoxEvent( reminder );
			monthReminder.date = finalDate;
			return monthReminder;				
		}
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY ) {	
			var reminderCurrentDate = reminder.date;
			// if start date is less than the default reminder date, then use the reminder date as start date
			if (  reminderFox_compareDates( startDate, reminderCurrentDate ) == -1 ) {
				startDate = reminderCurrentDate;
			}
			
			var reminderDay = reminder.date.getDay();
			var startDay = startDate.getDay();

			var compareCurrentDay = reminderDay + 1;
			var compareFirstDay = startDay + 1;
			var daysDifference;
			if ( compareCurrentDay < compareFirstDay ) {
				compareCurrentDay = compareCurrentDay + 7;
			}	
			daysDifference = (compareCurrentDay - compareFirstDay);
			finalDate = new Date( startDate.getFullYear(), startDate.getMonth(), startDate.getDate() + daysDifference, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes()  );
			var weeklyReminder = reminderFox_cloneReminderFoxEvent( reminder );
			weeklyReminder.date = finalDate;
			return weeklyReminder;				
		
		}	
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY_ALTERNATING ) {	
			var reminderCurrentDate = new Date( reminder.date.getFullYear(),  reminder.date.getMonth(), reminder.date.getDate(), reminder.date.getHours(), reminder.date.getMinutes()  );
			// if start date is less than the default reminder date, then use the reminder date as start date
			if (  reminderFox_compareDates( startDate, reminderCurrentDate ) == -1 ) {
				startDate = reminderCurrentDate;
			}

			var reminderDay = reminder.date.getDay();
			var startDay = startDate.getDay();

			var compareCurrentDay = reminderDay + 1;
			var compareFirstDay = startDay + 1;
			var daysDifference;
			if ( compareCurrentDay < compareFirstDay ) {
				compareCurrentDay = compareCurrentDay + 7;
			}	
			daysDifference = (compareCurrentDay - compareFirstDay);
			finalDate = new Date( startDate.getFullYear(), startDate.getMonth(), startDate.getDate() + daysDifference, reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes()  );

			// since this is alternating, determine if this week is the correct week, or if it is next week
			var numOfDaysDiff = reminderFox_computeNumberOfDaysDifference( reminder.date, finalDate );
		    var oddOrEven =  reminderFox_mod( numOfDaysDiff , 2);
	   		if ( oddOrEven != 0 ) {
	   		 	// we are an odd week away, need to add 7 to get to the next alternating week
	     		finalDate.setDate( finalDate.getDate() + 7 );
			}				
			
			var weeklyReminder = reminderFox_cloneReminderFoxEvent( reminder );
			weeklyReminder.date = finalDate;			
			return weeklyReminder;
		}
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_DAILY ) {	
			var reminderCurrentDate = reminder.date;
			// if start date is less than the default reminder date, return the reminder date
				if (  reminderFox_compareDates( startDate, reminderCurrentDate ) == -1 ) {
					return  reminderFox_cloneReminderFoxEvent( reminder );
				}
				var dailyReminder =   reminderFox_cloneReminderFoxEvent( reminder );
				dailyReminder.date =  new Date( startDate.getFullYear(), startDate.getMonth(), startDate.getDate(), reminderCurrentDate.getHours(), reminderCurrentDate.getMinutes()  );
				return dailyReminder;
			//}
		}						
		return null;
	}
	
function reminderFox_mod(divisee,base) {
	return Math.round(divisee - (Math.floor(divisee/base)*base));
}

function reminderFox_computeNumberOfDaysDifference( origStartDate, origEndDate ) {
	var startDate = new Date( origStartDate.getFullYear(), origStartDate.getMonth(), origStartDate.getDate(), 0, 0, 0 );
	var finalDate = new Date( origEndDate.getFullYear(), origEndDate.getMonth(), origEndDate.getDate(), 0, 0, 0 );
	
    // The number of milliseconds in one day
    var ONE_DAY = 1000 * 60 * 60 * 24

    // Convert both dates to milliseconds
    var date1_ms = startDate.getTime()
    var date2_ms = finalDate.getTime()

    // Calculate the difference in milliseconds
    var difference_ms = Math.abs(date1_ms - date2_ms)
    
    // Convert back to days and return
    var numOfDaysDiff =  Math.round(difference_ms/ONE_DAY);
    return numOfDaysDiff;
 }
	
function reminderFox_getWeekNumber( currentDate ) {
		var reminderDate = currentDate.getDate();
		var numberOfDay = reminderDate / 7;
		var intvalue =	parseInt( numberOfDay );
		if ( reminderDate % 7 == 0 ) {
			intvalue--;
		}
		var weekNumber = intvalue + 1;   // 0-based index
		if ( weekNumber == 5 ) {
			weekNumber = -1;  // set to last week of month
		}
		return weekNumber;
}
	
function reminderFox_getWindowEnumerator() {
	var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var windowEnumerator = windowManagerInterface.getEnumerator("navigator:browser");
	if ( windowEnumerator.hasMoreElements() ) {
		return windowEnumerator;
	}

	 windowEnumerator = windowManagerInterface.getEnumerator("mail:3pane");
	if ( windowEnumerator.hasMoreElements() ) {
		return windowEnumerator;
	}	
	
	windowEnumerator = windowManagerInterface.getEnumerator("mail:messageWindow");
	if ( windowEnumerator.hasMoreElements() ) {
		return windowEnumerator;
	}	
	
	return windowManagerInterface.getEnumerator("navigator:browser");
	
}
	
function reminderFox_playSound() {
	var gSound = Components.classes["@mozilla.org/sound;1"].createInstance(Components.interfaces.nsISound);
	var savefilePath;
	// check if user has specified a specific file path for sound in their preferences
	try {
		savefilePath = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ALARM_SOUND_PATH);
	}
	catch ( e) {
	}
	// if not, then play default beep sound
	if ( savefilePath == null || savefilePath == "" ) {
		gSound.beep();	
	}
	else {
		var file = Components.classes["@mozilla.org/file/local;1"]
						.createInstance(Components.interfaces.nsILocalFile);
			file.initWithPath( savefilePath );						
   			var ios = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
		var fileURI = ios.newFileURI(file);				
		gSound.play(fileURI);	
	}
}
	
		function reminderFox_getDateForSpecifiedWeekNumber( currentDate, dayNumber, weekNumber ) {
			var firstDate = new Date( currentDate.getFullYear(), currentDate.getMonth(), 1 );  
			var firstDayOfMonth = firstDate.getDay();
			
			// calculate the date that the first day-of-week falls on (using the day of the first of the month)
			var compareCurrentDay = dayNumber + 1;
			var compareFirstDay = firstDayOfMonth + 1;
			if ( compareCurrentDay < compareFirstDay ) {
				compareCurrentDay = compareCurrentDay + 7;
			}
			var firstWeekDateVal = (compareCurrentDay - compareFirstDay) + 1;
			var finalDate;
			
			// we have the date that the first day-of-week falls on.  Now let's calculate the Nth day of week
			if ( weekNumber == -1 ) {  // last day of week of the month
				var weekNumberCalculation = 5 - 1;
				finalDate  = firstWeekDateVal + ( weekNumberCalculation*7);
				var lastDayOfMonth = oeDatePicker.getLastDayOfMonth( currentDate.getFullYear(), currentDate.getMonth() );
				if ( finalDate > lastDayOfMonth ) {
					finalDate  = finalDate - 7;   // previous (4th) week must be the last week of this month
				}
			}
			else {
				var weekNumberCalculation = weekNumber - 1;
				finalDate  = firstWeekDateVal + ( weekNumberCalculation*7);
			}
			
			return finalDate;
	}	
	
function reminderFox_getSortNewUpcomingReminderIndex( reminders, newreminder  ) {
	// We go through each reminder and then compare that reminder's month with 
	// the reminder-to-be-added month, and if the new month is less, add there;
	// if the months are equal, then compare the days and add appropriately. 

	// first check if the new reminder is greater than the last sorted reminder.  If so, add to 
	// end of the list...
	if ( reminders.length > 0 && reminderFox_compareDates( newreminder.date, reminders[reminders.length-1].date ) !=-1 ) {
			return reminders.length;
	}

	// otherwise, go through the list and insert where the new reminder is less than 
	// the reminders in the list
	for( var i = 0; i < reminders.length; i++ ) {
		var currentReminder = reminders[i];		
		if (  reminderFox_compareDates( newreminder.date, currentReminder.date ) == -1 ) {
			return i;
		}
	}	 

 	// if the reminder hasn't been added yet, then place it at the end
	// of the list
	return reminders.length;
}

	
	function reminderFox_getAllRemindersInDateRange( reminder, startDate, endDate, limitWeeklyReminders ) {
		var reminderArray = new Array();
		var i;

		// if reminder date is greater than the end date, then return empy array
		if ( reminderFox_compareDates( reminder.date, endDate ) == 1 ) {
			return reminderArray;
		}
		// if reminder date is greater than the start date, use the reminder date as the 
		// starting date
		if ( reminderFox_compareDates( reminder.date, startDate ) == 1 ) {
			startDate = reminder.date;
		}
 
		if ( reminder.recurrence  == REMINDER_RECURRENCE_ONETIME ) {
			if ( reminderFox_compareDates( reminder.date, endDate ) == 1 ) {
				// return nothing if the reminder is outside of the ending date
				return reminderArray;
			}
			else if ( reminderFox_compareDates( reminder.date, startDate ) == -1 ) {
				// return nothing if the reminder has already occurred prior to the starting date
				
				// unless it's marked as Remind Until Completed...  then return it if today 
				// falls within the date range
			 	if ( reminder.remindUntilCompleted == REMINDERFOX_REMIND_UNTIL_COMPLETE_MARKED ) {
			 		var todaysDate = new Date();
			 		if ( reminderFox_compareDates( todaysDate, startDate ) != -1 && 
			 		  reminderFox_compareDates( todaysDate, endDate )  != 1 ) {
				 		reminderArray[0] = reminder;
				 	}
		 		}
			
				return reminderArray;
			}	
			else {
				reminderArray[0] = reminder;
				return reminderArray;
			}
		}	
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY ) { 
			var yearReminder = reminderFox_getFirstReminderOccurrenceAfterStartDate( reminder, startDate );

			if ( yearReminder != null  ) {
				if ( reminderFox_compareDates( yearReminder.date, endDate ) == 1 ) {
					// return nothing if the reminder is outside of the ending date
					return reminderArray;
				}
				else {
					reminderArray[0] = yearReminder;
					return reminderArray;
				}		
			}
			return reminderArray;
		}
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY_DAY ) { 
			var yearReminder = reminderFox_getFirstReminderOccurrenceAfterStartDate( reminder, startDate );

			if ( yearReminder != null  ) {
				if ( reminderFox_compareDates( yearReminder.date, endDate ) == 1 ) {
					// return nothing if the reminder is outside of the ending date
					return reminderArray;
				}
				else {
					reminderArray[0] = yearReminder;
					return reminderArray;
				}		
			}
			return reminderArray;
		}				
		else 	if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DATE ) {
			var arrayIndex = 0;
			var monthReminder = reminderFox_getFirstReminderOccurrenceAfterStartDate( reminder, startDate );
			if ( monthReminder != null  ) {
				if ( reminderFox_compareDates(  monthReminder.date, endDate ) == 1 ) {
					// return nothing if the reminder is outside of the ending date
					return reminderArray;
				}											
				while ( reminderFox_compareDates( monthReminder.date, endDate ) != 1 ) {				
					reminderArray[arrayIndex] = monthReminder;					
					monthReminder = reminderFox_getNextReminderOccurrence( monthReminder, reminder.date, 0 );
					arrayIndex++;
				}
			}
			return reminderArray;
		}
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DAY ) {
			var arrayIndex = 0;
			var monthReminder = reminderFox_getFirstReminderOccurrenceAfterStartDate( reminder, startDate );
			if ( monthReminder != null  ) {
				if ( reminderFox_compareDates(  monthReminder.date, endDate ) == 1 ) {
					// return nothing if the reminder is outside of the ending date
					return reminderArray;
				}	
				var weekNumber = reminderFox_getWeekNumber( reminder.date );										
				while ( reminderFox_compareDates( monthReminder.date, endDate ) != 1 ) {				
					reminderArray[arrayIndex] = monthReminder;					
					monthReminder = reminderFox_getNextReminderOccurrence( monthReminder, reminder.date, weekNumber );
					arrayIndex++;
				}
			}
			return reminderArray;		

		}
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY ) {	
			var arrayIndex = 0;
			var weeklyReminder = reminderFox_getFirstReminderOccurrenceAfterStartDate( reminder, startDate );
			if ( weeklyReminder != null  ) {
				if ( reminderFox_compareDates(  weeklyReminder.date, endDate ) == 1 ) {
					// return nothing if the reminder is outside of the ending date
					return reminderArray;
				}		
								
				var result = getDayAndEndDayOfYear( weeklyReminder, endDate );
				var dayOfYear = result.dayResult;
				var endDayOfYear  = result.endResult;				
				
				var endIndex = 365;
				if ( limitWeeklyReminders ) {
					endIndex = 8;
				}
					
				while ( dayOfYear <= endDayOfYear && arrayIndex < endIndex) {
					reminderArray[arrayIndex] = weeklyReminder;	
					
					weeklyReminder	= reminderFox_cloneReminderFoxEvent(weeklyReminder);
					weeklyReminder.date = new Date( weeklyReminder.date.getFullYear(), weeklyReminder.date.getMonth(), weeklyReminder.date.getDate() + 7, weeklyReminder.date.getHours(), weeklyReminder.date.getMinutes()  );
					arrayIndex++;				
					dayOfYear = dayOfYear + 7;
				
				}
						
				
				//	reminderArray[arrayIndex] = weeklyReminder;		
				//	return reminderArray;
//				while ( reminderFox_compareDates( weeklyReminder.date, endDate ) != 1  && arrayIndex < 5) {			
//					reminderArray[arrayIndex] = weeklyReminder;					
//					weeklyReminder = reminderFox_getNextReminderOccurrence( weeklyReminder, reminder.date, weekNumber );
//					arrayIndex++;
//				}
			}
			return reminderArray;				
		}	
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY_ALTERNATING ) {	
			var arrayIndex = 0;
			var weeklyReminder = reminderFox_getFirstReminderOccurrenceAfterStartDate( reminder, startDate );
			if ( weeklyReminder != null  ) {
				if ( reminderFox_compareDates(  weeklyReminder.date, endDate ) == 1 ) {
					// return nothing if the reminder is outside of the ending date
					return reminderArray;
				}					
								
				var result = getDayAndEndDayOfYear( weeklyReminder, endDate );
				var dayOfYear = result.dayResult;
				var endDayOfYear  = result.endResult;			

				var endIndex = 365;
				if ( limitWeeklyReminders ) {
					endIndex = 8;
				}
					
				while ( dayOfYear <= endDayOfYear && arrayIndex < endIndex) {
					reminderArray[arrayIndex] = weeklyReminder;	
					
					weeklyReminder	= reminderFox_cloneReminderFoxEvent(weeklyReminder);
					weeklyReminder.date = new Date( weeklyReminder.date.getFullYear(), weeklyReminder.date.getMonth(), weeklyReminder.date.getDate() + 14, weeklyReminder.date.getHours(), weeklyReminder.date.getMinutes()  );
					arrayIndex++;				
					dayOfYear = dayOfYear + 14;				
				}				
				
									
//				while ( reminderFox_compareDates( weeklyReminder.date, endDate ) != 1 ) {				
//					reminderArray[arrayIndex] = weeklyReminder;					
//					weeklyReminder = reminderFox_getNextReminderOccurrence( weeklyReminder, reminder.date, weekNumber );
//					arrayIndex++;
//				}
			}
			return reminderArray;				
		}
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_DAILY) {	
			var arrayIndex = 0;
			var dailyReminder = reminderFox_getFirstReminderOccurrenceAfterStartDate( reminder, startDate );
			if ( dailyReminder != null  ) {
				if ( reminderFox_compareDates(  dailyReminder.date, endDate ) == 1 ) {
					// return nothing if the reminder is outside of the ending date
					return reminderArray;
				}					
								
				var result = getDayAndEndDayOfYear( dailyReminder, endDate );
				var dayOfYear = result.dayResult;
				var endDayOfYear  = result.endResult;

				var endIndex = 365;
				if ( limitWeeklyReminders ) {
					var	endIndex = 8;
				}
				while ( dayOfYear <= endDayOfYear && arrayIndex < endIndex) {
					reminderArray[arrayIndex] = dailyReminder;	
					
					dailyReminder	= reminderFox_cloneReminderFoxEvent(dailyReminder);
					dailyReminder.date = new Date( dailyReminder.date.getFullYear(), dailyReminder.date.getMonth(), dailyReminder.date.getDate() + 1, dailyReminder.date.getHours(), dailyReminder.date.getMinutes()  );
					arrayIndex++;				
					dayOfYear = dayOfYear + 1;				
				}												
			}
			return reminderArray;	
				
				
		}
		
		return null;
	}
	
	function getDayAndEndDayOfYear( weeklyReminder, endDate) {
		var dayArray;
		var month = weeklyReminder.date.getMonth();
		var day = weeklyReminder.date.getDate();
		var currentYear = weeklyReminder.date.getFullYear();
		if (reminderFox_isLeapYear(currentYear) ) {
			dayArray = REMINDER_FOX_lDOMonth;
		}
		else {
			dayArray = REMINDER_FOX_DOMonth;
		}
	
		var dayOfYear=0;
		for (var  i=0; i < month; i++) {
			dayOfYear += dayArray[i];
		}
		dayOfYear += day;		

		var endDayOfYear=0;
		if ( endDate.getFullYear() != currentYear ) {
			if (reminderFox_isLeapYear(endDate.getFullYear() ) ) {
				dayArray = REMINDER_FOX_lDOMonth;
			}
			else {
				dayArray = REMINDER_FOX_DOMonth;
			}
			endDayOfYear += 365;
		}
		month = endDate.getMonth();
		day = endDate.getDate();

		for ( i=0; i < month; i++) {
			endDayOfYear += dayArray[i];
		}
		endDayOfYear += day;	
		var result = { dayResult: dayOfYear, endResult:  endDayOfYear};
		return result;
	}
	
// return -1 if dateOne < dateTwo
// return 0 if equal
// return 1 if dateOne > dateTwo
function reminderFox_compareDates( dateOne, dateTwo ) {
	var t1 = dateOne.getTime();
	var t2 = dateTwo.getTime();

    // Calculate the difference in milliseconds
    var difference_ms = Math.abs(t1 - t2)
    
    if ( difference_ms/REMINDER_FOX_ONE_DAY < 2 ) { // if under 2 days difference, do more precise check to take into account the time
		// do the year compare
		if ( dateOne.getFullYear() < dateTwo.getFullYear() ) {
			return -1;
		}
		else if ( dateOne.getFullYear() > dateTwo.getFullYear() ) {
			return 1;
		}
		else {  // same year
			if ( dateOne.getMonth() < dateTwo.getMonth() ) {
				return -1;
			}
			else if ( dateOne.getMonth() > dateTwo.getMonth() ) {
				return 1;
			}
			else { // same month
				if ( dateOne.getDate() < dateTwo.getDate() ) {
					return -1;
				}
				else if ( dateOne.getDate() > dateTwo.getDate() ) {
					return 1;
				}
				else {
					return 0;   // same exact dates
				}
			}
		}			
	}
	else {
		if ( t1 < t2 ) {
			return -1;
		}
		else if ( t1 > t2 ) {
			return 1;
		}
		else{
			return 0;
		}	
	}
}
	
	function reminderFox_getReminderStoreFile() {
		var file;
		var savefilePath;
		// check if user has specified a specific file path in their preferences
		try {
			savefilePath = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_STORE_FILE);
		}
		catch ( e) {
		}
		// if not, then use default location in profile
		if ( savefilePath == null || savefilePath == "" ) {
			 file = Components.classes["@mozilla.org/file/directory_service;1"]
           		  .getService(Components.interfaces.nsIProperties)
        	      .get("ProfD", Components.interfaces.nsIFile);

		      file.append( "reminderfox" );
		      file.append( "reminderfox.ics" );			
		}
		else {
			file = Components.classes["@mozilla.org/file/local;1"]
						.createInstance(Components.interfaces.nsILocalFile);
			file.initWithPath( savefilePath );
		}
		return file;
	}

	function reminderFox_getFileTimeStamp() {
		var file =   reminderFox_getReminderStoreFile();
	
	     // bail if the file doesn't yet exist; no reminders to read
	      if ( !file.exists() ) { 
	      	return -1;
	      }			
		try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		} catch (e) {
			alert("Permission to read file was denied.");
		}
	
		var is = Components.classes["@mozilla.org/network/file-input-stream;1"]
			.createInstance( Components.interfaces.nsIFileInputStream );
		try {
			is.init( file,0x01, 00004, null);
		}
		catch ( e ) {
			reminderFox_logMessageLevel("Could not read reminder file: " + e.name  +  " -- " + e.message, REMINDER_FOX_LOG_LEVEL_INFO);
			return -1;
		}
		
		var scriptableStream = Components.classes["@mozilla.org/scriptableinputstream;1"]
		                                 .createInstance(Components.interfaces.nsIScriptableInputStream);
		scriptableStream.init(is);
		var chunk = scriptableStream.read(scriptableStream.available());		
		
		// maybe only read set # of bytes

		return reminderFox_getFileTimeStampFromString(chunk);
	}

	function reminderFox_getFileTimeStampFromString(chunk) {
		var index =	chunk.indexOf( REMINDERFOX_FILE_LAST_MODIFIED);
		if ( index != -1 ) {
			var newline = "\n";
			var returnLine = "\r";
			index = chunk.indexOf( ':', index );
			if ( index != -1 ) {
				var endIndex = chunk.indexOf( newline, index );
				var time = chunk.substring( index+1, endIndex );
				if ( time.charAt( time.length-1) == returnLine ) {
					time = time.substring( 0, time.length-1);
				}
				return reminderFox_trim(time);
			}
		}
		return -1;
	}

	function reminderFox_getReminderEvents() {
		if ( reminderFoxEvents == null ) {
			reminderFoxEvents = new Array();
			reminderFoxTodos = new Array();
			var file =   reminderFox_getReminderStoreFile();
	
	     // bail if the file doesn't yet exist; no reminders to read
	      if ( !file.exists() ) { 
	      	return reminderFoxEvents;
	      }			
		  reminderFox_readInRemindersAndTodosICS(reminderFoxEvents, reminderFoxTodos, file, false);
		}
		return reminderFoxEvents;
	}
	
	function reminderFox_getReminderTodos() {
		if ( reminderFoxTodos == null ) {
			reminderFoxEvents = new Array();
			reminderFoxTodos = new Array();
			var file = reminderFox_getReminderStoreFile();
	
	     // bail if the file doesn't yet exist; no reminders to read
	      if ( !file.exists() ) { 
	      	return reminderFoxTodos;
	      }			
		  reminderFox_readInRemindersAndTodosICS(reminderFoxEvents, reminderFoxTodos, file, false);
		}
		return reminderFoxTodos;
	}
	
	function reminderFox_clearRemindersAndTodos() {
		reminderFoxEvents = null;
		reminderFoxTodos = null;
	}
	
	function reminderFox_getRemindersById( id ) {
		var reminders = reminderFox_getReminderEvents();
		for ( var i = 0; i < reminders.length; i++ ) {
			if ( reminders[i].id == id ) {
				return reminders[i];
			}
		}
		return null;
	}
	
	function reminderFox_getTodosById( id ) {
		var todos = reminderFox_getReminderTodos();
		for ( var i = 0; i < todos.length; i++ ) {
			if ( todos[i].id == id ) {
				return todos[i];
			}
		}
		return null;
	}

function reminderFox_isInteger(s)
{  
 var i;
    for (i = 0; i < s.length; i++) {   
        // Check that current character is number.
        var c = s.charAt(i);
        if (((c < "0") || (c > "9"))) return false;
    }
    // All characters are numbers.
    return true;
}

function reminderFox_initiliazeTooltip() {
	reminderFox_ensureRemindersSynchronized();
	
	reminderFox_logMessageLevel("Tooltip initialized" + new Date(), REMINDER_FOX_LOG_LEVEL_FINE);
	
}

// add some extra checks in when hiding tooltip; in case the setTimeout threads have been suspended, 
// this will kick them off again if neccessary
function reminderFox_hideTooltip() {
	reminderFox_initializeReminderFoxHourly();
	reminderFox_showAlertSlider();
}


function reminderFox_ensureRemindersSynchronized() {
	var fileChanged = reminderFox_timeStampHasChanged();
	if ( fileChanged != -1 ) {
		var changed = false;
		try { 
			var waitForResponse = reminderFox_ensureRemoteRemindersSynchronized(true); 
			if ( !waitForResponse ) {
				changed = reminderFox_processRecentReminders(); 
			}
		}
		catch ( e ) {
		}		
		if ( changed ) {
			// write stuff out
			reminderFox_writeOutRemindersAndTodos(false);								
			reminderFox_syncWrittenChangesToRemote();		
		}
		else {
			//reminderFox_logMessageLevel("FOO:storing time stamp from ensureSync: " + fileChanged, REMINDER_FOX_LOG_LEVEL_FINE);	 
			reminderFox_storeTimeStamp(fileChanged);
		}
		
		var windowEnumerator =  reminderFox_getWindowEnumerator();
	
		if (windowEnumerator.hasMoreElements()) {
			var oldestWindow = windowEnumerator.getNext();		
			oldestWindow.reminderFox_updateRemindersInWindow();	
			reminderFox_clearRemindersAndTodos();
			while (windowEnumerator.hasMoreElements()) {
				var currentWindow = windowEnumerator.getNext();		
				currentWindow.reminderFox_updateRemindersInWindow();		
				currentWindow.reminderFox_clearRemindersAndTodos();						
			}
		}	
		
		//reminderFox_ensureRemoteRemindersSynchronized(true); 
	}	
	
	 return fileChanged != -1;
}
	
/*
 * check the reminder description for any variables (eg: <1978>) that needs translating
 */	
function reminderFox_processReminderDescription( reminder, year ) {
	var index = reminder.summary.indexOf( "<" );
	if ( index != -1 ) {
		var endIndex = reminder.summary.indexOf( ">", index + 1 );
		if ( endIndex != -1 ) {
			var yearVal = reminder.summary.substring( index + 1, endIndex );
			if ( yearVal.length == 4 ) {
				try {
					if (!reminderFox_isInteger(yearVal) ) {
						return reminder;
					}
					var yearInt = parseInt(yearVal );
					var currentYear = year;
					if ( currentYear == null ) {
						currentYear =  new Date().getFullYear();
					}
					var numOfYears = currentYear - yearInt;
					var numOfYearsStr = numOfYears + "";
					if ( numOfYears > 0 && numOfYears < 32 ) {
						numOfYearsStr = reminderFox_getBundle().getString("rf.options.dateshort." +numOfYears +".name");
					}
					else {					
						var length = numOfYearsStr.length;
	
						if ( numOfYearsStr.lastIndexOf("11") != -1 && numOfYearsStr.lastIndexOf("11") == length -2 ) {
							numOfYearsStr =numOfYearsStr + reminderFox_getBundle().getString("rf.options.number.abbreviation.4");
						}
						else if ( numOfYearsStr.lastIndexOf("12") != -1 && numOfYearsStr.lastIndexOf("12") == length - 2 ) {
							numOfYearsStr =numOfYearsStr + reminderFox_getBundle().getString("rf.options.number.abbreviation.4");
						}
						else if (  numOfYearsStr.lastIndexOf("13") != -1 && numOfYearsStr.lastIndexOf("13") == length -2 ) {
							numOfYearsStr =numOfYearsStr + reminderFox_getBundle().getString("rf.options.number.abbreviation.4");
						}											
						else if (  numOfYearsStr.lastIndexOf("1") != -1 &&numOfYearsStr.lastIndexOf("1") == length - 1) {
							numOfYearsStr =numOfYearsStr + reminderFox_getBundle().getString("rf.options.number.abbreviation.1");
						}
						else if (numOfYearsStr.lastIndexOf("2") != -1 && numOfYearsStr.lastIndexOf("2") == length -1  ) {
							numOfYearsStr =numOfYearsStr + reminderFox_getBundle().getString("rf.options.number.abbreviation.2");
						}	
						else if ( numOfYearsStr.lastIndexOf("3") != -1 && numOfYearsStr.lastIndexOf("3") == length - 1 ) {
							numOfYearsStr =numOfYearsStr + reminderFox_getBundle().getString("rf.options.number.abbreviation.3");
						}	
						else {
							numOfYearsStr =numOfYearsStr + reminderFox_getBundle().getString("rf.options.number.abbreviation.4");
						}			
					}								

					var returnReminder = reminderFox_cloneReminderFoxEvent(reminder);
					returnReminder.summary = returnReminder.summary.substring( 0, index ) + numOfYearsStr + 
						returnReminder.summary.substring( endIndex + 1 );
					return returnReminder;					
				}
				catch ( e ) {
				}
			}
		}
	}
	return reminder;
}	


function reminderFox_trim(s) {
	// Remove leading spaces and carriage returns
	while ((s.substring(0,1) == ' ') ) {
	 	s = s.substring(1,s.length); 
	 }
	
	// Remove trailing spaces and carriage returns
	while ((s.substring(s.length-1,s.length) == ' ') ) { 
		s = s.substring(0,s.length-1); 
	}

	return s;
}


function reminderFox_constructReminderOutput(reminderEvents, reminderTodos, isExport ) {
	var newline;
	if (navigator.appVersion.lastIndexOf('Win') != -1) {
		newline="\r\n";
	} else {
		newline="\n"
	}
	//var separator = newline + " :" ;
	var separator =  ":" ;
	
		
	var outputStr = "BEGIN:VCALENDAR" + newline;
	outputStr += "VERSION" + separator +  
							"2.0" + newline;
	outputStr += "PRODID" + separator + 
							 "-//ReminderFox V" + REMINDER_FOX_MIGRATED_PREF_VERSION +"//EN" + newline;
	var modifiedTime;
	
	// if exporting (via file or network), use existing timestamp
	 if ( isExport ) {
	 	modifiedTime = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LAST_MODIFIED) + "";
	 }
	 else {	 		
	 	// otherwise, we're writing the file anew - set new current timestamp					 
		 reminderFox_lastModifiedTime = new Date().getTime();
		 modifiedTime = reminderFox_lastModifiedTime;
	}
	outputStr += REMINDERFOX_FILE_LAST_MODIFIED + separator + modifiedTime + newline;							 
	outputStr += "METHOD" + separator +  
							"PUBLISH" + newline;
	
	// REMINDERS
	var reminder;
	//var tzOffset = new Date().getTimezoneOffset();
	
	for ( var i = 0; i < reminderEvents.length; i++ ) {
		reminder = reminderEvents[i];
		var summary = reminder.summary;
		outputStr += "BEGIN:VEVENT" +  newline;	
		outputStr += "UID" + separator +  
								reminder.id + newline;				
		outputStr += "SUMMARY" + separator +  
								summary + newline;			
		if ( isExport ) {
			outputStr += "CLASS" + separator +  
								"PUBLIC" + newline;		
		}																					
		
		var currentDate =  new Date( reminder.date.getFullYear(), reminder.date.getMonth(), reminder.date.getDate(), reminder.date.getHours(), reminder.date.getMinutes() );
		
		//currentDate.setMinutes( currentDate.getMinutes() + tzOffset );	// set this offset for UTC	
		var year = currentDate.getFullYear();
		var month = currentDate.getMonth() +1;
		var day = currentDate.getDate();
		if (month < 10)
			month = "0" + month;
		if (day < 10)
			day = "0" + day;
		
		if ( reminder.allDayEvent ) {
			outputStr += "DTSTART;VALUE=DATE" + separator +  
									"" + year  + month  + day + newline;				
						
									
			if ( isExport ) {
				// if we are exporting reminders, then add the end-date for all day events because
				// some buggy clients don't understnand all-day events that have no end date even though
				// that is correct in the ICS spec
				currentDate.setDate( currentDate.getDate() + 1 );
				year = currentDate.getFullYear();
				month = currentDate.getMonth() +1;
				day = currentDate.getDate();
				if (month < 10)
					month = "0" + month;
				if (day < 10)
					day = "0" + day;				
				outputStr += "DTEND;VALUE=DATE" + separator +  
									"" + year  + month  + day + newline;						
			}																	
		}
		else {
			var hours = currentDate.getHours();
			var minutes = currentDate.getMinutes();
			if (hours < 10)
				hours = "0" + hours;
			if (minutes < 10)
				minutes = "0" + minutes;

			outputStr += "DTSTART" + separator +  
									"" + year + month +  day + "T" + hours  + minutes + "00" + newline;				
								//	"" + year + month +  day + "T" + hours  + minutes + "00Z" + newline;					// add Z for UTC

			if ( isExport ) {
				currentDate.setHours( currentDate.getHours() + 1 );
				year = currentDate.getFullYear();
				month = currentDate.getMonth() +1;
				day = currentDate.getDate();
				if (month < 10)
					month = "0" + month;
				if (day < 10)
					day = "0" + day;							
				hours = currentDate.getHours();
				minutes = currentDate.getMinutes();
				if (hours < 10)
					hours = "0" + hours;
				if (minutes < 10)
					minutes = "0" + minutes;								
				outputStr += "DTEND" + separator +  
							"" + year + month +  day + "T" + hours  + minutes + "00" + newline;			
			}								
		}
		
		if ( reminder.notes != null ) {
			var LINE_LENGTH = 78;
			// replace actual new line  with newline characters
			var desc =reminder.notes.replace(new RegExp(/\n/g),"\\n");
//			if ( desc.length > LINE_LENGTH ) {
//					outputStr += "DESCRIPTION" + separator +  desc.substring( 0, LINE_LENGTH ) + newline;		
//					var index = LINE_LENGTH;
//					while ( (index +LINE_LENGTH)< desc.length ) {
//						outputStr += " " + desc.substring( index, index + LINE_LENGTH ) + newline;		
//						index = index +LINE_LENGTH;
//					}
//					outputStr += " " + desc.substring( index, desc.length ) + newline;							
//			}
//			else {
					outputStr += "DESCRIPTION" + separator +  
							desc + newline;		
			}
//		}


		var endRepeatUntil = "";
		if ( reminder.recurrenceEndDate != null ) {
			//currentDate.setMinutes( currentDate.getMinutes() + tzOffset );	// set this offset for UTC	
			var year = reminder.recurrenceEndDate.getFullYear();
			var month = reminder.recurrenceEndDate.getMonth() +1;
			var day = reminder.recurrenceEndDate.getDate();
			if (month < 10)
				month = "0" + month;
			if (day < 10)
				day = "0" + day;

			endRepeatUntil += ";UNTIL=" + separator +  
										"" + year  + month  + day + newline;
		}	
//				var hours = currentDate.getHours();
//				var minutes = currentDate.getMinutes();
//				if (hours < 10)
//					hours = "0" + hours;
//				if (minutes < 10)
//					minutes = "0" + minutes;
//	
//				outputStr += "DTSTART" + separator +  
//										"" + year + month +  day + "T" + hours  + minutes + "00" + newline;				
//									//	"" + year + month +  day + "T" + hours  + minutes + "00Z" + newline;					// add Z for UTC
//				if ( isExport ) {
//					currentDate.setHours( currentDate.getHours() + 1 );
//					year = currentDate.getFullYear();
//					month = currentDate.getMonth() +1;
//					day = currentDate.getDate();
//					if (month < 10)
//						month = "0" + month;
//					if (day < 10)
//						day = "0" + day;							
//					hours = currentDate.getHours();
//					minutes = currentDate.getMinutes();
//					if (hours < 10)
//						hours = "0" + hours;
//					if (minutes < 10)
//						minutes = "0" + minutes;								
//					outputStr += "DTEND" + separator +  
//								"" + year + month +  day + "T" + hours  + minutes + "00" + newline;			
//				}								
//			}




		if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY ) {
			outputStr += "RRULE" + separator +  
									"FREQ=YEARLY;INTERVAL=1;BYMONTH=" + month + endRepeatUntil + newline;				
		}
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_YEARLY_DAY ) {
			var weekNumber = reminderFox_getWeekNumber( reminder.date );
			outputStr += "RRULE" + separator +  
									"FREQ=YEARLY;INTERVAL=1;BYMONTH=" + month +";BYDAY=" + weekNumber + reminderFox_weekday[reminder.date.getDay()] +endRepeatUntil + newline;					
		}		
		else 	if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DATE ) {
			outputStr += "RRULE" + separator +  
									 "FREQ=MONTHLY;INTERVAL=1"+ endRepeatUntil +  newline;							
		}   
		else if ( reminder.recurrence  == REMINDER_RECURRENCE_MONTHLY_DAY ) {
			var weekNumber = reminderFox_getWeekNumber( reminder.date );
			outputStr += "RRULE" + separator +  
									 "FREQ=MONTHLY;INTERVAL=1;BYDAY=" +  weekNumber + reminderFox_weekday[reminder.date.getDay()]+ endRepeatUntil + newline;	
		}
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY ) {		
			outputStr += "RRULE" + separator +  
									"FREQ=WEEKLY;INTERVAL=1;BYDAY=" + reminderFox_weekday[reminder.date.getDay()] + endRepeatUntil + newline;				
		}
		else	if ( reminder.recurrence  == REMINDER_RECURRENCE_WEEKLY_ALTERNATING ) {		
			outputStr += "RRULE" + separator +  
									"FREQ=WEEKLY;INTERVAL=2;BYDAY=" + reminderFox_weekday[reminder.date.getDay()]+ endRepeatUntil + newline;							
		}		
		else 	if ( reminder.recurrence  == REMINDER_RECURRENCE_DAILY ) {
			outputStr += "RRULE" + separator +  
									 "FREQ=DAILY"+  newline;							
		}   		
		else {		
			// no recurrence string for REMINDER_RECURRENCE_ONETIME
		}		
		
		if ( reminder.priority == REMINDER_PRIORITY_IMPORTANT) { 
			outputStr += "PRIORITY" + separator +  
									"1" + newline;				
		}

		if ( reminder.lastModified != null ) {
			outputStr += "LAST-MODIFIED" + separator +  reminder.lastModified + newline;			
		}
		
		if (reminder.remindUntilCompleted != 0) {
			outputStr += "X-REMINDERFOX-REMIND-UNTIL-COMPLETED" + separator +  
									 reminder.remindUntilCompleted + newline;					
		}
		if (reminder.complete != 0) {
			outputStr += "X-REMINDERFOX-COMPLETE" + separator +  
									 "1" + newline;							
		}		
		if ( reminder.alarm != null ) {
			outputStr += "BEGIN:VALARM" + newline;	
			outputStr += "TRIGGER;VALUE=DURATION" + separator +  
									reminder.alarm + newline;
			if ( reminder.alarmLastAcknowledge != null ) {
				outputStr +="X-REMINDERFOX-LASTACK" + separator + reminder.alarmLastAcknowledge + newline;	
			}			
			outputStr += "END:VALARM" + newline;	
		}
		outputStr += "END:VEVENT" + newline;			
	}

	
	// TODOs
	var todo;
	for (  i = 0; i < reminderTodos.length; i++ ) {
		todo = reminderTodos[i];
		outputStr += "BEGIN:VTODO" +  newline;				
		outputStr += "SUMMARY" + separator +  
								todo.summary + newline;		
		outputStr += "UID" + separator +  
								todo.id+ newline;														


		if ( todo.notes != null ) {
			var LINE_LENGTH = 78;
			
			// replace actual new line  with newline characters
			var desc = todo.notes.replace(new RegExp(/\n/g),"\\n");
//			if ( desc.length > LINE_LENGTH ) {
//					outputStr += "DESCRIPTION" + separator +  desc.substring( 0, LINE_LENGTH ) + newline;		
//					var index = LINE_LENGTH;
//					while ( (index +LINE_LENGTH)< desc.length ) {
//						outputStr += " " + desc.substring( index, index + LINE_LENGTH ) + newline;		
//						index = index +LINE_LENGTH;
//					}
//					outputStr += " " + desc.substring( index, desc.length ) + newline;							
//			}
//			else {
					outputStr += "DESCRIPTION" + separator +  
							desc + newline;		
			}

		if ( todo.priority == REMINDER_PRIORITY_IMPORTANT) { 
			outputStr += "PRIORITY" + separator +  
									"1" + newline;					
		}
		
		
		if ( todo.complete ) { 
			outputStr += "PERCENT-COMPLETE" + separator +  
									"100" + newline;					
		}		
				
		if (todo.showInTooltip) {
			outputStr += "X-REMINDERFOX-SHOW-IN-TOOLTIP" + separator +  
									"1" + newline;		
		}
		outputStr += "END:VTODO" +  newline;		
	}
		
	outputStr += "END:VCALENDAR" +  newline;		

	return outputStr;
}

function reminderFox_getDateAsString(  currentDate ) {
	var dateString = "";
	var year = currentDate.getFullYear();
	var month = currentDate.getMonth() +1;
	var day = currentDate.getDate();
	if (month < 10)
		month = "0" + month;
	if (day < 10)
		day = "0" + day;
	
	var hours = currentDate.getHours();
	var minutes = currentDate.getMinutes();
	var seconds = currentDate.getSeconds();
	if (hours < 10)
		hours = "0" + hours;
	if (minutes < 10)
		minutes = "0" + minutes;
	if (seconds < 10)
		seconds = "0" + seconds;		

	dateString= year + month +  day + "T" + hours  + minutes + seconds;		
	return dateString;
						// + "00Z" + newline;					// add Z for UTC
}

function reminderFox_getStringAsDate(  dateString ) {	
	var date;
	var timeIndex = dateString.indexOf( "T" );
	var month = dateString.substring( 4,6);
	if ( month.indexOf( "0" ) == 0 ) {
		month = month.substring(1);
	}
	var monthInt = parseInt( month ) - 1;	
	// event with specific hourly time
	date = new Date( dateString.substring( 0, 4 ), monthInt,  dateString.substring( 6, 8 ) );
	date.setHours( dateString.substring( 9, 11 ), dateString.substring( 11, 13 ), dateString.substring( 13, 15) );
	
	// if event is stored in UTC time (20051208T224616Z), then take into accoutn UTC offset for the 
	// current time
	if ( dateString.length > 15 && dateString.charAt(15) == "Z" ) {  
		var tzOffset = new Date().getTimezoneOffset(); 
		date.setMinutes( date.getMinutes() - tzOffset );						
	}	
	return date;
}

function reminderFox_writeOutRemindersAndTodos( isExport ) {	
	var outputStr = reminderFox_constructReminderOutput(reminderFox_getReminderEvents(), reminderFox_getReminderTodos(), isExport);
	
	// now write file out to filesystem
	var file = reminderFox_getReminderStoreFile();
 
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} catch (e) {
		alert("Permission to save file was denied.");
	}

	if ( file.exists() == false ) {
		file.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420 );
	}

	reminderFox_writeStringToFile(outputStr, file, false);

}

function reminderFox_syncWrittenChangesToRemote() {
	// sync 'em up 
	var networkSync = REMINDER_FOX_NETWORK_SYNCHRONIZE_DEFAULT;		
	try {
		networkSync = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_NETWORK_SYNCHRONIZE);
	} catch(e) {
	}	
	if ( networkSync ) {
		reminderFox_uploadReminders();
	}	
}

function reminderFox_uploadReminders() {
	var newOptions = { closeOnNoErrors: 1 };
	window.openDialog('chrome://reminderFox/content/network/upload.xul', 'reminderFox-upload', 'modal, centerscreen', newOptions);
}

function reminderFox_downloadReminders() {
	var newOptions = { closeOnNoErrors: 1 };
	window.openDialog('chrome://reminderFox/content/network/download.xul', 'reminderFox-download', 'modal,centerscreen', newOptions);
}

function reminderFox_writeStringToFile( outputStr, file, isExport ) {
	var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
		.createInstance( Components.interfaces.nsIFileOutputStream );
	outputStream.init( file, 0x04 | 0x08 | 0x20, 420, 0 );
	
	var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
	                          .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	converter.charset = "UTF-8";
	
	var chunk = null;
	try {
		chunk = converter.ConvertFromUnicode(outputStr);
	}
	catch( e ) {
		chunk = outputStr;
	}
	outputStream.write(chunk, chunk.length);	
	
	 var fin = converter.Finish();
	 if (fin.length > 0)
	   outputStream.write(fin, fin.length);
	 outputStream.close();

	//reminderFox_logMessageLevel("FOO:storing time stamp from writeStringToFile" + reminderFox_lastModifiedTime, REMINDER_FOX_LOG_LEVEL_FINE);	 
	if ( !isExport && reminderFox_lastModifiedTime != null ) { 
		 reminderFox_storeTimeStamp(reminderFox_lastModifiedTime);
	}
}

function reminderFox_storeTimeStamp(lastModified) {
	//var file = reminderFox_getReminderStoreFile();
	//var lastModified =  file.lastModifiedTime  
	reminderFox_prefsBranch.setCharPref(REMINDER_FOX_LAST_MODIFIED, 	lastModified);
	reminderFox_logMessageLevel("Store time stamp: " + new Date() + " -- " + lastModified, REMINDER_FOX_LOG_LEVEL_INFO);	 
}	

function reminderFox_timeStampHasChanged( ) {
	var timestamp = 	reminderFox_getFileTimeStamp()
	var lastRecordedTimeStamp = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LAST_MODIFIED) + "";
//	currentTimeStamp =  file.lastModifiedTime;			
	var fileChanged = lastRecordedTimeStamp != timestamp;	
	reminderFox_logMessageLevel("TimeStamp Changed: " + new Date() + " - " + fileChanged + " --lastRecorded:" + lastRecordedTimeStamp + "--currentTimeStamp:" + timestamp +"-", REMINDER_FOX_LOG_LEVEL_INFO);	 
	
	if ( fileChanged ) {
		return timestamp;
	}
	else {
		return -1;
	}
}	




// split a string at newlines:   \n (Mac, *nix) or \r\n  (windows)
function reminderFox_splitOnAllNewlines(input) {
	// just use common newline to read in lines - check for strings that end in \r (to handle windows \r\n)
	var newline = "\n";
	var returnLine = "\r";
	
	var remindersArray = input.split(newline);	
	for ( var index = 0; index < remindersArray.length; index++ ) {
		var readIn = remindersArray[index];	
		if (readIn.length > 0 &&  readIn.lastIndexOf(returnLine) == readIn.length -1 ) {
			readIn = readIn.substring(0, readIn.length -1 );
			remindersArray[index] = readIn;
		}
	}	
	return remindersArray;
}


function reminderFox_readInReminderEvent(reminderEvent, index, readIn, remindersArray) {
    var colonIndex;
	while ( index < remindersArray.length && readIn != "END:VEVENT" ) {
		if ( readIn.indexOf( "SUMMARY" ) == 0 ) {
			colonIndex = readIn.indexOf( ":" );
			while ( colonIndex == -1 ) {
				index++;
				readIn = remindersArray[index];
				colonIndex = readIn.indexOf( ":" );
			}
			reminderEvent.summary = readIn.substring( colonIndex + 1);			
		}
		
		if ( readIn.indexOf( "DESCRIPTION" ) == 0 ) {
			 // there can be multiple notes DESCRIPTION fields; if we have already set the notes field,
			 // then we'll skip it if we encounter another one
			var skipNotes = reminderEvent.notes != null; 
				
			colonIndex = readIn.indexOf( ":" );
			while ( colonIndex == -1 ) {
				index++;
				readIn = remindersArray[index];
				colonIndex = readIn.indexOf( ":" );
			}
			if ( !skipNotes ) {
				reminderEvent.notes = readIn.substring( colonIndex + 1);	
			}
			// DESCRIPTION could span multiple lines (that start with space characters).   Check for this
			var breakIt = false;		
			while ( !breakIt &&  index < remindersArray.length - 1 ) {
				if ( remindersArray[index + 1].indexOf( " " ) == 0 ) {
					index++;
					readIn = remindersArray[index];
					if ( !skipNotes ) {
						reminderEvent.notes = reminderEvent.notes + readIn.substring( 1, readIn.length);			
					}					
				}
				else {
					breakIt = true;
				}
			}
			// replace new line characters with actual newline
			reminderEvent.notes = reminderEvent.notes.replace(new RegExp(/\\n/g),"\n");
		}		
		
		if ( readIn.indexOf( "UID" ) == 0 ) {
			colonIndex = readIn.indexOf( ":" );
			while ( colonIndex == -1 ) {
				index++;
				readIn = remindersArray[index];
				colonIndex = readIn.indexOf( ":" );
			}
			reminderEvent.id = readIn.substring( colonIndex + 1 );			
		}		


		if ( readIn.indexOf( "LAST-MODIFIED" ) == 0 ) {
			colonIndex = readIn.indexOf( ":" );
			while ( colonIndex == -1 ) {
				index++;
				readIn = remindersArray[index];
				colonIndex = readIn.indexOf( ":" );
			}
			reminderEvent.lastModified = readIn.substring( colonIndex + 1 );			
		}		

		if ( readIn.indexOf( "PRIORITY" ) == 0 ) {
			colonIndex = readIn.indexOf( ":" );
			while ( colonIndex == -1 ) {
				index++;
				readIn = remindersArray[index];
				colonIndex = readIn.indexOf( ":" );
			}
			reminderEvent.priority = readIn.substring( colonIndex + 1 );		
		}			
		
		if ( readIn.indexOf( "X-REMINDERFOX-REMIND-UNTIL-COMPLETED" ) == 0 ) {
			colonIndex = readIn.indexOf( ":" );
			while ( colonIndex == -1 ) {
				index++;
				readIn = remindersArray[index];
				colonIndex = readIn.indexOf( ":" );
			}
			reminderEvent.remindUntilCompleted = readIn.substring( colonIndex + 1 );			
		}	

		if ( readIn.indexOf( "X-REMINDERFOX-COMPLETE" ) == 0 ) {
			colonIndex = readIn.indexOf( ":" );
			while ( colonIndex == -1 ) {
				index++;
				readIn = remindersArray[index];
				colonIndex = readIn.indexOf( ":" );
			}
			reminderEvent.complete = readIn.substring( colonIndex + 1 );		
		}		
		
		if ( readIn.indexOf( "BEGIN:VALARM" ) == 0 ) {
			index++;
			readIn = remindersArray[index];		
			colonIndex = readIn.indexOf( ":" );
			while ( colonIndex == -1 ) {
				index++;
				readIn = remindersArray[index];
				colonIndex = readIn.indexOf( ":" );
			}
			var alarmTime = readIn.substring( colonIndex + 1 );
			reminderEvent.alarm = alarmTime;
			
//			var alarmIndex1 = alarmTime.indexOf( "-PT" );
//			if ( alarmIndex1 != -1 ) {
//				var alarmIndex2 = alarmTime.indexOf( "M", alarmIndex1 );
//				if ( alarmIndex2 != -1 ) {
//					alarmTime = alarmTime.substring( alarmIndex1 + "-PT".length, alarmIndex2 );
//					reminderEvent.alarm = alarmTime;
//				}
//			}
		}	
		
		if ( readIn.indexOf( "X-REMINDERFOX-LASTACK" ) == 0 ) {
			colonIndex = readIn.indexOf( ":" );
			while ( colonIndex == -1 ) {
				index++;
				readIn = remindersArray[index];
				colonIndex = readIn.indexOf( ":" );
			}
			
			var alarmLastAcknowledge = readIn.substring( colonIndex + 1 );
			reminderEvent.alarmLastAcknowledge = alarmLastAcknowledge;
		}
				
		if ( readIn.indexOf( "DTSTART" ) == 0 ) {
			colonIndex = readIn.indexOf( ":" );
			while ( colonIndex == -1 ) {
				index++;
				readIn = remindersArray[index];
				colonIndex = readIn.indexOf( ":" );
			}
			var eventDate = readIn.substring( colonIndex + 1 );			
			var timeIndex = readIn.indexOf( "T", colonIndex );
			var month = eventDate.substring( 4,6);
			if ( month.indexOf( "0" ) == 0 ) {
				month = month.substring(1);
			}
			var monthInt = parseInt( month ) - 1;	
			if ( timeIndex == -1 ) {   
				// all day event
				reminderEvent.date = new Date( eventDate.substring( 0, 4 ), monthInt, eventDate.substring( 6, 8) );				
			}
			else {
				// event with specific hourly time
				reminderEvent.date = new Date( eventDate.substring( 0, 4 ), monthInt,  eventDate.substring( 6, 8 ) );
				reminderEvent.date.setHours( eventDate.substring( 9, 11 ), eventDate.substring( 11, 13 ) );
				
				// if event is stored in UTC time (20051208T224616Z), then take into accoutn UTC offset for the 
				// current time
				if ( eventDate.length > 15 && eventDate.charAt(15) == "Z" ) {  
					var tzOffset = new Date().getTimezoneOffset(); 
					reminderEvent.date.setMinutes( reminderEvent.date.getMinutes() - tzOffset );						
				}
				
				reminderEvent.allDayEvent = false;
			}			
		}									

		if ( readIn.indexOf( "RRULE" ) == 0 ) {
			colonIndex = readIn.indexOf( ":" );
			while ( colonIndex == -1 ) {
				index++;
				readIn = remindersArray[index];
				colonIndex = readIn.indexOf( ":" );
			}
			var rrule =  readIn.substring( colonIndex + 1 );
			if ( rrule.indexOf( "FREQ=YEARLY")  != -1  ) {				
				var byDayIndex = rrule.indexOf( "BYDAY=" );
				if ( byDayIndex != -1 ) {	
					// yearly on day
					reminderEvent.recurrence = REMINDER_RECURRENCE_YEARLY_DAY; 
				}
				else {			
					reminderEvent.recurrence = REMINDER_RECURRENCE_YEARLY;
				}
			}
			else 	if ( rrule.indexOf( "FREQ=MONTHLY" ) != -1  ) {
				var byDayIndex = rrule.indexOf( "BYDAY=" );
				if ( byDayIndex != -1 ) {	
					if ( rrule.indexOf( "INTERVAL=12") != -1  ) {	
						// yearly on day
						reminderEvent.recurrence = REMINDER_RECURRENCE_YEARLY_DAY; 
					}
					else {
						// monthly on day
						reminderEvent.recurrence = REMINDER_RECURRENCE_MONTHLY_DAY; 					
					}
				}
				else {
					// monthly on date
					reminderEvent.recurrence = REMINDER_RECURRENCE_MONTHLY_DATE; 
				}
			}
			else 	if ( rrule.indexOf( "FREQ=WEEKLY")  != -1  ) {
				var intervalIndex = rrule.indexOf( "INTERVAL=" );
				if ( intervalIndex != -1 ) {	
					var totalIndex = intervalIndex + "INTERVAL=".length;
					var interval = rrule.substring( totalIndex, totalIndex + 1 );
					if (interval == "2" ) {
						reminderEvent.recurrence = REMINDER_RECURRENCE_WEEKLY_ALTERNATING;
					}
					else {
						reminderEvent.recurrence = REMINDER_RECURRENCE_WEEKLY;
					}
				}
			}
			else 	if ( rrule.indexOf( "FREQ=DAILY")  != -1  ) {
				reminderEvent.recurrence = REMINDER_RECURRENCE_DAILY;
			}			
			// ;UNTIL=20060504T035959;INTERVAL=1
			var repeatUntil =  rrule.indexOf( "UNTIL=");
			if ( repeatUntil != -1 ) {
				 var endRepeatUntil =  rrule.indexOf( ";", repeatUntil);
				 if ( endRepeatUntil == -1 ) {
				 	endRepeatUntil = rrule.length - 1;
				 }
				
				var repeatUntilStr = rrule.substring( repeatUntil + "UNTIL=".length, endRepeatUntil );
				var timeIndex = repeatUntilStr.indexOf( "T", colonIndex );
				var month = eventDate.substring( 4,6);
				if ( month.indexOf( "0" ) == 0 ) {
					month = month.substring(1);
				}
				var monthInt = parseInt( month ) - 1;	
				if ( timeIndex == -1 ) {   
					// all day event
					reminderEvent.recurrenceEndDate = new Date( repeatUntilStr.substring( 0, 4 ), monthInt, repeatUntilStr.substring( 6, 8) );				
				}
				else {
					// event with specific hourly time
					reminderEvent.recurrenceEndDate = new Date( repeatUntilStr.substring( 0, 4 ), monthInt,  repeatUntilStr.substring( 6, 8 ) );
					reminderEvent.recurrenceEndDate.setHours( repeatUntilStr.substring( 9, 11 ), repeatUntilStr.substring( 11, 13 ) );
					
					// if event is stored in UTC time (20051208T224616Z), then take into accoutn UTC offset for the 
					// current time
					if ( repeatUntilStr.length > 15 && repeatUntilStr.charAt(15) == "Z" ) {  
						var tzOffset = new Date().getTimezoneOffset(); 
						reminderEvent.recurrenceEndDate.setMinutes( reminderEvent.recurrenceEndDate.getMinutes() - tzOffset );						
					}
				}
			}
		}		
	
	
		index++;
		readIn = remindersArray[index];
	}	
	
	
	return index;


}



function reminderFox_readInReminderTodo(reminderTodo, index, readIn, remindersArray) {
	while ( index < remindersArray.length && readIn != "END:VTODO" ) {
		if ( readIn.indexOf( "SUMMARY" ) == 0 ) {
			var colonIndex = readIn.indexOf( ":" );
			while ( colonIndex == -1 ) {
				index++;
				readIn = remindersArray[index];
				colonIndex = readIn.indexOf( ":" );
			}
			reminderTodo.summary = readIn.substring( colonIndex + 1);			
		}
		
		if ( readIn.indexOf( "UID" ) == 0 ) {
			var colonIndex = readIn.indexOf( ":" );
			while ( colonIndex == -1 ) {
				index++;
				readIn = remindersArray[index];
				colonIndex = readIn.indexOf( ":" );
			}
			reminderTodo.id = readIn.substring( colonIndex + 1 );			
		}		

		if ( readIn.indexOf( "DESCRIPTION" ) == 0 ) {
			var colonIndex = readIn.indexOf( ":" );
			while ( colonIndex == -1 ) {
				index++;
				readIn = remindersArray[index];
				colonIndex = readIn.indexOf( ":" );
			}
			reminderTodo.notes = readIn.substring( colonIndex + 1);	

			// DESCRIPTION could span multiple lines (that start with space characters).   Check for this
			var breakIt = false;		
			while ( !breakIt &&  index < remindersArray.length - 1 ) {
				if ( remindersArray[index + 1].indexOf( " " ) == 0 ) {
					index++;
					readIn = remindersArray[index];
					reminderTodo.notes = reminderTodo.notes + readIn.substring( 1, readIn.length);								
				}
				else {
					breakIt = true;
				}
			}
			
			// replace new line characters with actual newline
			reminderTodo.notes = reminderTodo.notes.replace(new RegExp(/\\n/g),"\n");		
		}			
		
		
		if ( readIn.indexOf( "PRIORITY" ) == 0 ) {
			var colonIndex = readIn.indexOf( ":" );
			while ( colonIndex == -1 ) {
				index++;
				readIn = remindersArray[index];
				colonIndex = readIn.indexOf( ":" );
			}
			reminderTodo.priority = readIn.substring( colonIndex + 1 );		
		}			
		
		if ( readIn.indexOf( "PERCENT-COMPLETE" ) == 0 ) {
			var colonIndex = readIn.indexOf( ":" );
			while ( colonIndex == -1 ) {
				index++;
				readIn = remindersArray[index];
				colonIndex = readIn.indexOf( ":" );
			}
			var completePercent = readIn.substring( colonIndex + 1 );		
			if ( completePercent == "100" ) {
				reminderTodo.complete = true;
			}
		}		
		
		if ( readIn.indexOf( "X-REMINDERFOX-SHOW-IN-TOOLTIP" ) == 0 ) {
			var colonIndex = readIn.indexOf( ":" );
			while ( colonIndex == -1 ) {
				index++;
				readIn = remindersArray[index];
				colonIndex = readIn.indexOf( ":" );
			}
			reminderTodo.showInTooltip = readIn.substring( colonIndex + 1 );			
		}	
	
		index++;
		readIn = remindersArray[index];
	}	
		
	return index;
}

function reminderFox_readInRemindersAndTodosICS(reminderEvents, reminderTodos, file, checkNewlines) {

	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} catch (e) {
		alert("Permission to read file was denied.");
	}

	var is = Components.classes["@mozilla.org/network/file-input-stream;1"]
		.createInstance( Components.interfaces.nsIFileInputStream );
	try {
		is.init( file,0x01, 00004, null);
	}
	catch ( e ) {
		reminderFox_logMessageLevel("Could not read reminder file: " + e.name  +  " -- " + e.message, REMINDER_FOX_LOG_LEVEL_INFO);
		return;
	}

	reminderFox_readInRemindersAndTodosICSFromStream(reminderEvents, reminderTodos, is, checkNewlines);
}

/* Called also from download.js */
function reminderFox_readInRemindersAndTodosICSFromStream(reminderEvents, reminderTodos, is, checkNewlines) {
	var reminderEventsIndex = 0;
	var reminderTodosIndex = 0;
	var i, j;

	var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
	                          .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	converter.charset = /* The character encoding you want, using UTF-8 here */ "UTF-8";
	
	// Now, read from the stream
	var scriptableStream = Components.classes["@mozilla.org/scriptableinputstream;1"]
	                                 .createInstance(Components.interfaces.nsIScriptableInputStream);
	scriptableStream.init(is);
	var chunk = scriptableStream.read(scriptableStream.available());
	var input = null;
	try {
		 input = converter.ConvertToUnicode(chunk);
	}
	catch( e ) {
		// if the conversion fails (say importing from a previous version before the conversion code was in place)
		// then just set the input to the read-in value
		input = chunk;
	}		

	var remindersArray;

	// if reading from a source that could be from a different OS (usually on import), 
	// then check the newlines as they could differ from the current OS
	//if ( checkNewlines ) {
	// actually..  if sharing the stored reminders location between windows/linux or sharing remotely, 
	// we need to check the newlines everytime
	if ( true ) { 
		remindersArray = reminderFox_splitOnAllNewlines(input);
	}		
	else {
		var newline;
		if (navigator.appVersion.lastIndexOf('Win') != -1) {
			newline="\r\n";
		} else {
			newline="\n"
		}	
		remindersArray = input.split(newline);	
	}	

	var index = 0;
	var readIn = remindersArray[index];
	// bypass header 
	while ( index < remindersArray.length  ) {
		if ( readIn == "BEGIN:VEVENT" ) {
			var reminderEvent = new ReminderFoxEvent( null, null, null );
			reminderEvent.recurrence = REMINDER_RECURRENCE_ONETIME;
			index = reminderFox_readInReminderEvent( reminderEvent, index, readIn, remindersArray);
			reminderEvents[reminderEventsIndex] = reminderEvent;
			reminderEventsIndex++;
		}
		if ( readIn == "BEGIN:VTODO" ) {
			var reminderTodo = new ReminderFoxTodo( null, null );
			index = reminderFox_readInReminderTodo( reminderTodo, index, readIn, remindersArray);
			reminderTodos[reminderTodosIndex] = reminderTodo;
			reminderTodosIndex++;			
		}		
		index++;
		readIn = remindersArray[index];
	}

}

function reminderFox_importRemindersUpdateAll( isNetworkImport, lastModifiedTime) {
	// escape all commas
	for ( i = 0; i < reminderFoxEvents.length; i++ ) {
		reminderFoxEvents[i].summary = reminderFoxEvents[i].summary.replace(/\\,/g,",")
	}
	for ( i = 0; i < reminderFoxTodos.length; i++ ) {
		reminderFoxTodos[i].summary = reminderFoxTodos[i].summary.replace(/\\,/g,",")
	}
	
	if ( lastModifiedTime != null ) {
		reminderFox_lastModifiedTime = lastModifiedTime;
		reminderFox_storeTimeStamp(reminderFox_lastModifiedTime);
	}

	var outputStr = reminderFox_constructReminderOutput(reminderFoxEvents, reminderFoxTodos, isNetworkImport);
	
	// now write file out to filesystem
	var file =   reminderFox_getReminderStoreFile();
 
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	} catch (e) {
		alert("Permission to save file was denied.");
	}
	

	if ( file.exists() == false ) {
		file.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420 );
	}

	reminderFox_writeStringToFile(outputStr, file, false);

	// update all windows with imported reminders
	try {
		var windowEnumerator =  reminderFox_getWindowEnumerator();
	
		// update all of the browsers
		while (windowEnumerator.hasMoreElements()) {
			var currentWindow = windowEnumerator.getNext();		
			currentWindow.reminderFoxEvents = reminderFoxEvents;
			currentWindow.reminderFoxTodos  = reminderFoxTodos;

			currentWindow.reminderFox_updateRemindersInWindow();			
			currentWindow.reminderFox_clearRemindersAndTodos();
		}
	}
	catch(e) {
	}
	
      
}




